//-->left Click - Place.
//-->Hit bomb with a melee weapon to diffuse.

datablock StaticShapeData(BaseRaidersC4Shape)
{
	shapeFile = "./C4Placed.dts";
};

addDamageType("BaseRaidersC4Radius", '<bitmap:Add-Ons/GameMode_BaseRaiders/C4/CI> %1', '%2 <bitmap:Add-Ons/GameMode_BaseRaiders/C4/CI> %1', 1, 0);

datablock ProjectileData(BaseRaidersC4Explosion : rocketlauncherProjectile)
{
	directDamage			= 150; //75
	radiusDamageType		= $DamageType::BaseRaidersC4Radius;
	radiusDamageType		= $DamageType::BaseRaidersC4Radius;
	explosion			= gravityRocketExplosion;
	explodeOnDeath			= true;

	brickExplosionRadius		= 5;
	brickExplosionForce		= 20;
	brickExplosionMaxVolume		= 150;
	brickExplosionMaxVolumeFloating	= 150;

	lifetime			= 1;

	uiName				= "";
};

datablock ItemData(BaseRaidersC4Item)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./C4Held.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "C4";
	iconName = "./Icon";
	doColorShift = false;

	image = BaseRaidersC4Image;
	canDrop = true;
};

datablock ShapeBaseImageData(BaseRaidersC4Image)
{
	shapeFile = "./C4Held.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";

	correctMuzzleVector = false;

	eyeOffset = "0 0 0";

	item = BaseRaidersC4Item;
	ammo = " ";
	projectile = "";
	projectileType = "";

	melee = false;
	doRetraction = false;
	armReady = true;

	doColorShift = false;

	stateName[0]			= "Ready";
	stateTransitionOnTriggerDown[0]	= "Fire";
	stateAllowImageChange[0]	= true;

	stateName[1]			= "Fire";
	stateTransitionOnTimeout[1]	= "Ready";
	stateAllowImageChange[1]	= true;
	stateScript[1]			= "onFire";
	stateTimeoutValue[1]		= 1;
};

function BaseRaidersC4Image::onFire(%data, %obj, %slot)
{
	if(isObject(!%client = %obj.client))
	{
		return;
	}

	if(isObject(%client.C4))
	{
		commandToClient(%client, 'centerPrint', "Failed to plant C4.", 3);

		return;
	}

	%wall = containerRayCast(%obj.getEyePoint(), vectorAdd(%obj.getEyePoint(), vectorScale(%obj.getEyeVector(), 10)),($TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType));

	if(isObject(%wall))
	{
		%currSlot = %obj.currTool;
		%obj.tool[%currSlot] = 0;
		%obj.weaponCount--;
		messageClient(%client, 'MsgItemPickup', '', %currSlot, 0);
		serverCmdUnUseTool(%obj.client);

		%obj.unMountImage(%slot);

		if(firstWord(%wall).getType() & $TypeMasks::VehicleObjectType)
		{
			if(minigameCanDamage(%obj, firstWord(%wall)))
			{
				%client.C4 = firstWord(%wall);
				firstWord(%wall).setShapeName($BaseRaiders::C4DetonateTime);
				%client.C4Tick = %client.schedule(1000, BaseRaiders_C4CountDown, $BaseRaiders::C4DetonateTime);
				commandToClient(%client, 'centerPrint', "\c4C4 planted in vehicle.", 3);
			}

			else
			{
				commandToClient(%client, 'centerPrint', "Failed to plant C4.", 3);
			}

			return;
		}

		%C4 = new StaticShape()
		{
			datablock = BaseRaidersC4Shape;
			client = %client;
			mode = "timer";
		};

		missionCleanup.add(%C4);

		%client.C4 = %C4;

		%C4.setShapeNameDistance(1000);
		%C4.setShapeName($BaseRaiders::C4DetonateTime);

		%client.C4Display = 1;

		%hit = getWords(%wall, 1, 3);

		%client.C4Tick = %client.schedule(1000, BaseRaiders_C4CountDown, $BaseRaiders::C4DetonateTime);

		%angle = mRound(getWord(axisToEuler(getWords(%obj.getTransform(),3, 6)), 2));

		if(%angle < 0)
		{
			%angle += 360;
		}

		%direction = getWord(roundAngle(%angle), 1);
		%dir = getWord(roundAngle(%angle), 0);

		%trans = axisToEuler(getWords(%obj.getTransform(), 3, 6));
		%trans = setWord(%trans, 2, %direction);
		%trans = setWord(%trans, 0, 90);

		%C4.setTransform(%hit SPC eulerToAxis(%trans));

		%found = containerRayCast(%C4.getPosition(), vectorAdd(%C4.getPosition(), "0 0 0.1"), $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);

		if(isObject(%found))
		{
			%trans = axisToEuler(getWords(%obj.getTransform(),3, 6));
			%trans = setWord(%trans, 1, 180);
			%trans = vectorSub(%hit, "0 0 0.15") SPC eulerToAxis(%trans);
			%C4.setTransform(%trans);

			return;
		}

		%found = containerRayCast(vectorAdd(%C4.getPosition(), "0 0 0.2"), vectorSub(%C4.getPosition(), "0 0 0.1"), $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);

		if(isObject(%found))
		{
			%C4.setTransform(vectorAdd(%hit, "0 0 0.15") SPC getWords(%obj.getTransform(), 3, 6));

			return;
		}

		if(%dir $= "north" || %dir $= "east")
		{
			%C4.setTransform(vectorSub(%client.C4.getTransform(), "0 0.15"));
		}

		else if(%dir $= "south" || %dir $= "west")
		{
			%C4.setTransform(vectorAdd(%client.C4.getTransform(), "0 0.15"));
		}
	}

	else
	{
		commandToClient(%client, 'centerPrint', "Failed to plant C4.", 3);
	}
}

function BaseRaidersC4Image::onMount(%data, %obj, %slot)
{
	%obj.playThread(0, armReadyBoth);
}

function BaseRaidersC4Image::onUnMount(%data, %obj, %slot)
{
	%obj.playThread(0, root);
}

function BaseRaidersC4Explosion::onExplode(%data, %proj, %pos)
{
	%damageLeft = %data.directDamage;

	initContainerRadiusSearch(%pos, 3, $TypeMasks::FxBrickObjectType);

	while(isObject(%brick = containerSearchNext()))
	{
		%group = %brick.getGroup();

		//if(%group.bl_id == 888888 || (isObject(%proj.client) && %group.bl_id == %proj.client.getBLID() || %group == %client.gangBricks))
		//{
			//continue;
		//}

		if(!%damageLeft)
		{
			return;
		}

		%mini = getMiniGameFromObject(%brick);

		if(!%mini.phase)
		{
			continue;
		}

		%brickData = %brick.getDataBlock();

		if(%data.isBaseRaidersInvincible || %brick.isBaseRaidersInvincible)
		{
			continue;
		}

		if(!%brick.doObstructionCheck(%pos, $TypeMasks::FxBrickObjectType))
		{
			%damage = minClamp(%data.directDamage - (vectorDist(%pos, %brick.getPosition()) * 6) / minClamp(%brickData.baseRaidersStrengthMultiplier * $BaseRaiders::GeneralStrengthMultiplier, 1), 0);
			%damage = maxClamp(%damage, %data.directDamage);

			%brick.baseRaiders_damage(%damage, %proj.client);

			%damageLeft -= %damage;
		}
	}
}

function gameConnection::C4Detonate(%client, %killer)
{
	if(!isObject(%client.C4))
	{
		return;
	}

	if(!%killer)
	{
		%killer = %client;
	}

	cancel(%client.C4tick);

	%pos = %client.C4.getTransform();

	%p = new Projectile()
	{
		dataBlock = BaseRaidersC4Explosion;
		initialPosition  = %pos;
		initialVelocity = "0 0 0";
		client = %killer;
		sourceObject = %killer.player;
	};

	missionCleanup.add(%p);

	%client.C4.setShapeName("");

	if(%client.C4.getClassName() $= "StaticShape")
	{
		%client.C4.delete();
	}

	%client.C4 = "";
}

package BaseRaidersC4
{
	function projectileData::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);

		if(%col.getClassName() !$= "StaticShape" || !miniGameCanDamage(%proj, %col.client) || %col.getDatablock() !$= nameToID("BaseRaidersC4Shape") || !isObject(%proj.client.player.getMountedImage(0)))
		{
			return;
		}

		if(%proj.client.player.getMountedImage(0).isMelee())
		{
			if(isEventPending(%col.client.C4Tick))
			{
				%col.diffused = 1;
				%col.setShapeName("Diffused!");

				serverPlay3D(Beep_Denied_Sound, %col.getPosition());

				commandToClient(%proj.client, 'centerPrint', "\c4C4 bomb diffused.", 2);

				cancel(%col.client.C4Tick);
				%col.schedule(2000, delete);
			}
		}
	}

	function gameConnection::onClientLeaveGame(%client)
	{
		if(isObject(%client.C4))
		{
			%client.C4.delete();
		}

		parent::onClientLeaveGame(%client);
	}

	function gameConnection::onDeath(%client, %player, %killer, %damageType, %unknownA)
	{
		%client.C4Display = 0;

		parent::onDeath(%client, %player, %killer, %damageType, %unknownA);
	}
};
activatePackage(BaseRaidersC4);

function gameConnection::BaseRaiders_C4CountDown(%client, %time, %alTime, %mount)
{
	if(%mount $= "")
	{
		%mount = %client.C4;
	}

	if(!isObject(%mount) || %mount.diffused)
	{
		commandToClient(%client, 'clearCenterPrint');

		return;
	}

	if(%alTime $= "")
	{
		%alTime = 0;
	}

	if(%alTime == %time && %mount !$= "")
	{
		commandToClient(%client, 'clearCenterPrint');

		%client.C4Detonate();

		return;
	}

	serverPlay3D("ErrorSound", %mount.getPosition());

	%dis = %time - %altime;

	%mount.setShapeName(%dis);

	%minutes = %dis / 60;
	%minutes = mFloor(%minutes);

	if(%minutes < 10)
	{
		%minutes = "0" @ %minutes;
	}

	%seconds = %dis % 60;

	if(%seconds < 10)
	{
		%seconds = "0" @ %seconds;
	}

	if(%client.C4Display == 1)
	{
		commandToClient(%client, 'centerPrint', "<just:right>\c4Time Left:" NL "\c3" @ %minutes @ ":" @ %seconds @ " ", 4);
	}

	%client.C4.timeLeft = %minutes @ ":" @ %seconds;	
	%alTime++;

	%client.C4Tick = %client.schedule(1000, BaseRaiders_C4CountDown, %time, %altime, %mount);
}

function roundAngle(%angle)
{
	if(%angle == 360)
	{
		return "North 0";
	}

	if(%angle >= 0 && %angle < 45)
	{
		return "North 0";
	}

	if(%angle >= 45 && %angle < 135)
	{
		return "West 90";
	}

	if(%angle >= 135 && %angle < 225)
	{
		return "South 180";
	}

	if(%angle >= 225 && %angle < 315)
	{
		return "East 270";
	}

	if(%angle >= 315 && %angle < 360)
	{
		return "North 0";
	}

	else
	{
		return false;
	}
}