function player::isSentry(%obj)
{
	%data = %obj.getDataBlock();

	if(%obj.sentryKit !$= "" && (%obj.sentryXP !$= "" || %obj.sentryLevel !$= "") && (%data.getName() $= "PlayerSentryBottom" || %data.getName() $= "PlayerSentryTop") && %obj.sentryOwner !$= "" && (%obj.sentryTop !$= "" || %obj.sentryBottom !$= ""))
	{
		return true;
	}

	return false;
}

$sentryImage_BaseRaiders_1 = "sentryBaseRaidersTwoImage";
//$sentryImage_BaseRaiders_1 = "sentryBaseRaidersThreeImage";

$sentryUpgradeThreshold_BaseRaiders_2 = 0;

datablock AudioProfile(sentryBaseRaidersSound)
{
	fileName = "./sentryGunFire.wav";
	description = AudioClose3d;
	preload = true;
};

datablock ItemData(PlaceSentryBaseRaidersItem)
{
	category = "Item";
	
	shapeFile = "./sentryToolkitMG.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Sentry";
	iconName = "./icon_sentry_mg";
	doColorShift = false;
	colorShiftColor = "0.200 0.200 0.200 1.000";
	
	image = PlaceSentryBaseRaidersImage;
	canDrop = true;
};

datablock ShapeBaseImageData(PlaceSentryBaseRaidersImage)
{
	shapeFile = "./sentryToolkitMG.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0.2";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0.005 1.1 -0.65";
	eyeRotation = eulerToMatrix("-8 4 4");
	 
	correctMuzzleVector = false;
	className = "ToolImage";
	 
	item = PlaceSentryBaseRaidersItem;

	melee = true;
	armReady = false;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]	= "Ready";
	stateScript[0]			= "onActivate";
	stateSequence[0]		= "Activate";

	stateName[1]			= "Ready";
	stateScript[1]			= "onUse";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]			= "onFire";

	minShotTime = 20;
};

function PlaceSentryBaseRaidersImage::onMount(%data, %obj, %slot)
{
	if((%obj.lastFireTime + %data.minShotTime) > $Sim::Time)
	{
		if(isObject(%client = %obj.client))
		{
			%timeLeft = mRound(%data.minShotTime - ($Sim::Time - %obj.lastFireTime));
			%var = %timeLeft != 1 ? "seconds" : "second";

			commandToClient(%client, 'centerPrint', "Can't deploy another sentry yet!<br><br>Give it\c6" SPC %timeLeft SPC "\c0" @ %var SPC "to respawn...", mClampF(%timeLeft, 1, 5));
			serverCmdUnUseTool(%client);
		}

		%obj.playThread(2, undo);

		return;
	}

	%obj.playThread(1, armReadyBoth);
}

function PlaceSentryBaseRaidersImage::onUnMount(%data, %obj, %slot)
{
	%obj.playThread(0, root);
}

function PlaceSentryBaseRaidersImage::onActivate(%data, %obj, %slot)
{
	%obj.playThread(1, armReadyBoth);
}

function PlaceSentryBaseRaidersImage::onFire(%data, %obj, %slot)
{
	if(!isObject(%client = %obj.client) || !%mini = %client.isInBaseRaidersMini())
	{
		return;
	}

	%sentryCount = 0;

	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		%sentry = sentryGroup.getObject(%i);

		if(isObject(%sentry.sentryOwner) && isObject(%sentry.sentryOwner.gangBricks) && %sentry.sentryOwner.gangBricks == %obj.client.gangBricks)
		{
			%sentryGangCount++;
		}

		if(isObject(%sentry.sentryOwner) && %sentry.sentryOwner == %obj.client)
		{
			if(%sentryCount >= %mini.baseRaidersMaxPerPlayerSentries)
			{
				if(isObject(%sentry.sentryBottom))
				{
					%sentry.sentryBottom.delete();
				}

				%sentry.delete();

				continue;
			}

			%sentryCount++;
		}
	}

	if(%sentryGangCount >= %mini.baseRaidersMaxGangSentries)
	{
		commandToClient(%obj.client, 'centerPrint', "You can only have up to\c6" SPC %mini.baseRaidersMaxGangSentries SPC "\c0sentries at once in a gang!", 2);

		return;
	}

	if(%sentryCount >= %mini.baseRaidersMaxPerPlayerSentries)
	{
		commandToClient(%obj.client, 'centerPrint', "You can only have up to\c6" SPC %mini.baseRaidersMaxPerPlayerSentries SPC "\c0sentries at once!", 2);

		return;
	}

	createBaseRaidersSentryAtPlayer(%obj);

	%obj.lastFireTime = $Sim::Time;

	%obj.playThread(1, plant);
	%obj.playThread(2, activate2);

	messageClient(%client, 'MsgItemPickup', "", %obj.currTool, 0, 0);
	%obj.tool[%obj.currTool] = 0;
	//%obj.weaponCount--;
	serverCmdUnUseTool(%client);

	%fVec = %obj.getForwardVector();
	%fX = firstWord(%fVec);
	%fY = getWord(%fVec, 1);
  
	%eVec = %obj.getEyeVector();
	%eX = firstWord(%eVec);
	%eY = getWord(%eVec, 1);
	%eZ = getWord(%eVec, 2);
  
	%eXY = mSqrt(%eX * %eX + %eY * %eY);
  
	%aimVec = %fX * %eXY SPC %fY * %eXY SPC %eZ;

	%obj.setVelocity(vectorAdd(%obj.getVelocity(), vectorScale(%aimVec, -8)));

	serverPlay3D(sentryBuildSound, %obj.getPosition());
}

function createBaseRaidersSentryAtPlayer(%player)
{
	if($sentryOnePerPlayer && $BaseRaiders::SentryLimit == 1)
	{
		for(%i = 0; %i < sentryGroup.getCount(); %i++)
		{
			if(isObject(sentryGroup.getObject(%i).sentryOwner) && sentryGroup.getObject(%i).sentryOwner == %player.client)
			{
				sentryGroup.getObject(%i).kill();
			}
		}
	}

	%pos = vectorAdd(vectorScale(%player.getForwardVector(), 3) SPC "0 0 0 0", %player.getTransform());

	%bottom = new AIPlayer()
	{
		datablock = "PlayerSentryBottom";
		position = %pos;
		sentryOwner = %player.client;
		slyrTeam = %player.client.getTeam();
		sentryKit = "BaseRaiders";
		sentryXP = 0;
	};

	%top = new AIPlayer()
	{
		datablock = "PlayerSentryTop";
		sentryBottom = %bottom;
		sentryOwner = %player.client;
		slyrTeam = %player.client.getTeam();
	};

	%p = new Projectile()
	{
		dataBlock = toolboxExplosionProjectile;
		initialPosition = %pos;
		initialVelocity = "0 0 1";
		client = %player.client;
		sourceClient = %player.client;
	};

	%top.client = %top;
	%top.player = %top;
	%top.minigame = %player.client.minigame;
	%top.sentryLevel = 1;
	%top.sentryKit = "BaseRaiders";

	%bottom.client = %bottom;
	%bottom.player = %bottom;
	%bottom.minigame = %player.client.minigame;

	%top.hideNode("invisible");

	%bottom.mountObject(%top, 0);
	%top.setControlObject(%top); //must do this or it spins in circles

	%bottom.sentryTop = %top;
	%top.sentryBottom = %bottom;

	sentryGroup.add(%top);

	%top.mountImage($sentryImage_BaseRaiders_1, 0);

	if(!isEventPending($sentryLogicLoopSched))
	{
		sentryLogicLoop();
	}
}

//=========================================================================
// Level 2
//=========================================================================
addDamageType("SentryBaseRaiders2", '%1 <bitmap:Add-Ons/GameMode_BaseRaiders/Sentry/CI_s_mg2> %1', '%2 <bitmap:Add-Ons/GameMode_BaseRaiders/Sentry/CI_s_mg2> %1', 0.75, 1);

//projectile
datablock ProjectileData(sentryBaseRaidersTwoProjectile : gunProjectile)
{
	directDamage		= 20;
	directDamageType	= $DamageType::SentryBaseRaiders2;
	radiusDamageType	= $DamageType::SentryBaseRaiders2;

	impactImpulse		= 20;
	verticalImpulse		= 10;

	muzzleVelocity		= 200;
	velInheritFactor	= 0;

	lifetime		= 8000;
	fadeDelay		= 6500;

	uiName			= "";
};

datablock ShapeBaseImageData(sentryBaseRaidersTwoImage : gunImage)
{
	shapeFile = "./sentryMG2.1.dts";
	
	item = gunItem;
	projectile = sentryBaseRaidersTwoProjectile;

	doColorShift = false;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.75;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "Activate";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateTimeoutValue[1]		= 2.5;
	stateTransitionOnTimeout[1]	= "Ready2";
	stateSound[1]			= sentryBeepSound;
	stateSequence[1]		= "look1";

	stateName[4]			= "Ready2";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateAllowImageChange[4]	= true;
	stateTimeoutValue[4]		= 2.5;
	stateTransitionOnTimeout[4]	= "Ready";
	stateSound[4]			= sentryBeepSound;
	stateSequence[4]		= "look2";

	stateName[2]			= "Fire";
	stateTransitionOnTimeout[2]	= "Smoke";
	stateTimeoutValue[2]		= 0.12;
	stateFire[2]			= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]		= "Fire";
	stateScript[2]			= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= sentryBaseRaidersSound;
	stateEjectShell[2]		= true;

	stateName[3]			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.05;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]		= 0.01;
	stateTransitionOnTimeout[3]	= "Alerted";

	stateName[5]			= "Alerted";
	stateTransitionOnTriggerDown[5]	= "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]		= 2.5;
	stateTransitionOnTimeout[5]	= "Ready";
};

function sentryBaseRaidersTwoImage::onFire(%data, %obj, %slot)
{
	%projectile = %data.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = vectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = vectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = vectorAdd(%vector1, %vector2);
	
	%p = new (%data.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};

	missionCleanup.add(%p);

	return %p;
}

//=========================================================================
// Level 3
//=========================================================================
addDamageType("SentryBaseRaiders3", '%1 <bitmap:Add-Ons/GameMode_BaseRaiders/Sentry/CI_s_mg3> %1', '%2 <bitmap:Add-Ons/GameMode_BaseRaiders/Sentry/CI_s_mg3> %1', 0.75, 1);

//projectile
datablock ProjectileData(sentryBaseRaidersThreeProjectile : gunProjectile)
{
	directDamage		= 12;
	directDamageType	= $DamageType::SentryBaseRaiders3;
	radiusDamageType	= $DamageType::SentryBaseRaiders3;

	impactImpulse		= 10;
	verticalImpulse		= 10;

	muzzleVelocity		= 200;
	velInheritFactor	= 0;

	lifetime		= 8000;
	fadeDelay		= 6500;

	uiName			= "";
};

datablock ShapeBaseImageData(sentryBaseRaidersThreeImage : gunImage)
{
	shapeFile = "./sentryMinigun.1.dts";
	
	item = gunItem;
	projectile = sentryBaseRaidersThreeProjectile;

	doColorShift = false;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.75;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "Activate";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateAllowImageChange[1]	= true;
	stateTimeoutValue[1]		= 2.5;
	stateTransitionOnTimeout[1]	= "Ready2";
	stateSound[1]			= sentryBeepSound;
	stateSequence[1]		= "look1";

	stateName[4]			= "Ready2";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateAllowImageChange[4]	= true;
	stateTimeoutValue[4]		= 2.5;
	stateTransitionOnTimeout[4]	= "Ready";
	stateSound[4]			= sentryBeepSound;
	stateSequence[4]		= "look2";

	stateName[2]			= "Fire";
	stateTransitionOnTimeout[2]	= "Smoke";
	stateTimeoutValue[2]		= 0.06;
	stateFire[2]			= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]		= "fire";
	stateScript[2]			= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= sentryBaseRaidersSound;
	stateEjectShell[2]		= true;

	stateName[3]			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.05;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]		= 0.01;
	stateTransitionOnTimeout[3]	= "Alerted";

	stateName[5]			= "Alerted";
	stateTransitionOnTriggerDown[5]	= "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]		= 2.5;
	stateTransitionOnTimeout[5]	= "Ready";
};

function sentryBaseRaidersThreeImage::onFire(%data, %obj, %slot)
{
	%projectile = %data.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = ectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = ectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = vectorAdd(%vector1, %vector2);
	
	%p = new (%data.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};

	missionCleanup.add(%p);

	return %p;
}