//Not putting it as a required add-on because we're going to be modifying it quite a bit.

if(!isObject(sentryAlertSound))
{
	datablock AudioProfile(sentryAlertSound)
	{
		fileName = "./sentryAlert.wav";
		description = AudioClose3d;
		preload = true;
	};
}

if(!isObject(sentryBeepSound))
{
	datablock AudioProfile(sentryBeepSound)
	{
		fileName = "./sentryloop.wav";
		description = AudioClose3d;
		preload = true;
	};
}

$sentryTypeMasks = $TypeMasks::PlayerObjectType;

$sentryLoopTime = 100; //Time between bullets and target switching, etc.
$sentryTargetLength = 90; //How far away target can be.
$sentryAimOffset = "0 0 0.71"; //Modifier to where to aim at player(a little bit higher than default).
$sentryAimOffsetCrouched = "0 0 -0.5"; //Modifer to where to aim at player if he's crouching(a little lower).
$sentryRaycastMasks = $TypeMasks::FxBrickObjectType; //Masks for player raycast.
$sentryOnePerPlayer = 1; //Each player can only place one sentry?.
$sentryAnnounceToMinigame = 1; //Announce to everyone when a player's sentry dies?
$sentryWelderUpgradeRate = 3; //Rate at which sentry gains upgrade points(per hit).

$sentryTypeMasks = $TypeMasks::PlayerObjectType;

if(!isObject(SentryBottomDts))
{
	datablock TSShapeConstructor(SentryBottomDts)
	{
		baseShape  = "./sentryBottom.dts";
		sequence0  = "./sentry_root.dsq root";
		sequence1  = "./sentry_root.dsq run";
		sequence2  = "./sentry_root.dsq walk";
		sequence3  = "./sentry_root.dsq back";
		sequence4  = "./sentry_root.dsq side";
		sequence5  = "./sentry_root.dsq crouch";
		sequence6  = "./sentry_root.dsq crouchRun";
		sequence7  = "./sentry_root.dsq crouchBack";
		sequence8  = "./sentry_root.dsq crouchSide";
		sequence9  = "./sentry_look.dsq look";		//sentry_root.dsq
		sequence10 = "./sentry_root.dsq headside";
		sequence11 = "./sentry_root.dsq headUp";
		sequence12 = "./sentry_root.dsq jump";
		sequence13 = "./sentry_root.dsq standjump";
		sequence14 = "./sentry_root.dsq fall";
		sequence15 = "./sentry_root.dsq land";
		sequence16 = "./sentry_root.dsq armAttack";
		sequence17 = "./sentry_root.dsq armReadyLeft";
		sequence18 = "./sentry_root.dsq armReadyRight";
		sequence19 = "./sentry_root.dsq armReadyBoth";
		sequence20 = "./sentry_root.dsq spearready";  
		sequence21 = "./sentry_root.dsq spearThrow";
		sequence22 = "./sentry_root.dsq talk";  
		sequence23 = "./sentry_root.dsq death1"; 
		sequence24 = "./sentry_root.dsq shiftUp";
		sequence25 = "./sentry_root.dsq shiftDown";
		sequence26 = "./sentry_root.dsq shiftAway";
		sequence27 = "./sentry_root.dsq shiftTo";
		sequence28 = "./sentry_root.dsq shiftLeft";
		sequence29 = "./sentry_root.dsq shiftRight";
		sequence30 = "./sentry_root.dsq rotCW";
		sequence31 = "./sentry_root.dsq rotCCW";
		sequence32 = "./sentry_root.dsq undo";
		sequence33 = "./sentry_root.dsq plant";
		sequence34 = "./sentry_root.dsq sit";
		sequence35 = "./sentry_root.dsq wrench";
		sequence36 = "./sentry_root.dsq activate";
		sequence37 = "./sentry_root.dsq activate2";
		sequence38 = "./sentry_root.dsq leftrecoil";
	};
} 

if(!isObject(SentryTopDts))
{
	datablock TSShapeConstructor(SentryTopDts)
	{
		baseShape  = "./sentryTop.dts";
		sequence0  = "./empty_root.dsq root";
		sequence1  = "./empty_root.dsq run";
		sequence2  = "./empty_root.dsq walk";
		sequence3  = "./empty_root.dsq back";
		sequence4  = "./empty_root.dsq side";
		sequence5  = "./empty_root.dsq crouch";
		sequence6  = "./empty_root.dsq crouchRun";
		sequence7  = "./empty_root.dsq crouchBack";
		sequence8  = "./empty_root.dsq crouchSide";
		sequence9  = "./empty_look.dsq look";
		sequence10 = "./empty_root.dsq headside";
		sequence11 = "./empty_root.dsq headUp";
		sequence12 = "./empty_root.dsq jump";
		sequence13 = "./empty_root.dsq standjump";
		sequence14 = "./empty_root.dsq fall";
		sequence15 = "./empty_root.dsq land";
		sequence16 = "./empty_root.dsq armAttack";
		sequence17 = "./empty_root.dsq armReadyLeft";
		sequence18 = "./empty_root.dsq armReadyRight";
		sequence19 = "./empty_root.dsq armReadyBoth";
		sequence20 = "./empty_root.dsq spearready";  
		sequence21 = "./empty_root.dsq spearThrow";
		sequence22 = "./empty_root.dsq talk";  
		sequence23 = "./empty_root.dsq death1"; 
		sequence24 = "./empty_root.dsq shiftUp";
		sequence25 = "./empty_root.dsq shiftDown";
		sequence26 = "./empty_root.dsq shiftAway";
		sequence27 = "./empty_root.dsq shiftTo";
		sequence28 = "./empty_root.dsq shiftLeft";
		sequence29 = "./empty_root.dsq shiftRight";
		sequence30 = "./empty_root.dsq rotCW";
		sequence31 = "./empty_root.dsq rotCCW";
		sequence32 = "./empty_root.dsq undo";
		sequence33 = "./empty_root.dsq plant";
		sequence34 = "./empty_root.dsq sit";
		sequence35 = "./empty_root.dsq wrench";
		sequence36 = "./empty_root.dsq activate";
		sequence37 = "./empty_root.dsq activate2";
		sequence38 = "./empty_root.dsq leftrecoil";
	};
}

if(!isObject(PlayerSentryBottom))
{
	datablock PlayerData(PlayerSentryBottom : PlayerStandardArmor)
	{
		shapeFile = "./sentryBottom.dts";

		maxDamage = 150;

		boundingBox = "4.3 5.2 8";
		crouchBoundingBox = "4.3 5.2 8";

		thirdPersonOnly = 1;

		mass = 470;
		canJet = 0;
		uiName = "";
		maxForwardSpeed = 0;
		maxForwardCrouchSpeed = 0;
		maxBackwardSpeed = 0;
		maxBackwardCrouchSpeed = 0;
		maxSideSpeed = 0;
		maxSideCrouchSpeed = 0;
		jumpForce = 0;
	};
}

if(!isObject(PlayerSentryTop))
{
	datablock PlayerData(PlayerSentryTop : PlayerSentryBottom)
	{
		shapeFile = "./sentryTop.dts";

		cameraMaxDist = 4;
		cameraVerticalOffset = 0.6;
		cameraTilt = 0;
	};
}

if(!isObject(sentryGroup))
{
	new simGroup(sentryGroup);
}

if(!isPackage(sentryPackage))
{
	exec("./sentryPackage.cs");
}

function finishSentryBuild(%obj)
{
	%obj.isBuilt = 1;

	%obj.mountImage($sentryImage_BaseRaiders_1, 0);

	%pos = %obj.getPosition();

	%p = new Projectile()
	{
		dataBlock = sentryProjectile;
		initialPosition = %pos;
		initialVelocity = "0 0 1";
		client = %obj.client;
		sourceClient = %obj.client;
	};

	missionCleanup.add(%p);

	%p.explode();

	serverPlay3D(sentryAlertSound, %sentry.getPosition());
}

//These stop console spam.
//If you use these in something else, I'm sorry. Comment them out.
function AIPlayer::incScore(%obj, %num)
{
	//do nothing.
}

function AIPlayer::onDeath(%obj, %a, %source)
{
	//do nothing.
}

function playerSentryTop::onDisabled(%data, %obj, %state)
{
	if(isObject(%obj.sentryOwner))
	{
		if($sentryAnnounceToMinigame)
		{
			%obj.sentryOwner.minigame.messageAllExcept(%obj.sentryOwner, '', "\c3" @ %obj.sentryOwner.name @ "'s \c2sentry is \c0DOWN\c2!");
			messageClient(%obj.sentryOwner, '', "\c2Your sentry is \c0DOWN\c2!");
		}

		else
		{
			messageClient(%obj.sentryOwner, '', "\c2Your sentry is \c0DOWN\c2!");
		}
	}
	
	%pos = %obj.getPosition();

	%p = new Projectile()
	{
		dataBlock = gravityRocketProjectile;
		initialPosition = %pos;
		initialVelocity = "0 0 1";
		client = %obj.client;
		sourceClient = %obj.client;
	};

	missionCleanup.add(%p);

	%p.explode();
  
	if(isObject(%obj.sentryBottom))
	{
		%obj.sentryBottom.schedule(10, delete);
	}
  
	%obj.schedule(10, delete);

	if(%obj.getControllingClient())
	{
		%obj.getControllingClient().setControlObject(%obj.getControllingClient().player);
	}
}

function playerSentryBottom::onDisabled(%data, %obj, %state)
{
	%pos = %obj.getPosition();

	%p = new Projectile()
	{
		dataBlock = gravityRocketProjectile;
		initialPosition = %pos;
		initialVelocity = "0 0 1";
		client = %obj.client;
		sourceClient = %obj.client;
	};

	missionCleanup.add(%p);

	%p.explode();
  
	if(isObject(%obj.sentryTop))
	{
		%obj.sentryTop.schedule(10, delete);
	}
  
	%obj.schedule(10, delete);
}

function sentryLogicLoop()
{
	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		%sentry = sentryGroup.getObject(%i);

		if(!isObject(%sentry.sentryOwner))
		{
			%sentry.kill();
		}

		if(isObject(%mini = %sentry.sentryOwner.minigame) && %sentry.getState() !$= "Dead" && %mini.phase)
		{
			if(!isObject(%sentry.target) || %sentry.target.getState() $= "Dead" || vectorLen(vectorSub(%sentry.target.getPosition(), %sentry.getPosition())) > $sentryTargetLength || containerRayCast(%sentry.getPosition(), %sentry.target.getPosition(), $sentryRaycastMasks) != 0)
			{
				%sentry.target = "";
				//acquire target
				%len = $sentryTargetLength + 1;

				for(%c = 0; %c < clientGroup.getCount(); %c++)
				{
					%player = clientGroup.getObject(%c).player;

					if(isObject(%player) && minigameCanDamage(%sentry.sentryOwner, %player) && %player != %sentry.sentryOwner.player && %player.isCloaked != 1)
					{
						%checkLen = vectorLen(vectorSub(%player.getPosition(), %sentry.getPosition()));

						if(%checkLen < %len)
						{
							if(containerRayCast(%sentry.getPosition(), %player.getPosition(), $sentryRaycastMasks) == 0)
							{
								//found new target
								%sentry.target = %player;
								%len = %checkLen;
								%targetAcquired = 1;
							}
						}
					}
				}

				if(%targetAcquired)
				{
					//play sentry beep sound
					serverPlay3D(sentryalertsound, %sentry.getPosition());
				}
			}
			
			//if you have a target, shoot at it
			if(isObject(%sentry.target) && %sentry.target.getState() !$= "Dead" && %sentry.getState() !$= "Dead")
			{
				//aim
				if(%sentry.target.isCrouched())
				{
					%sentry.setAimLocation(vectorAdd(%sentry.target.getPosition(), $sentryAimOffsetCrouched));
				}

				else
				{
					%sentry.setAimLocation(vectorAdd(%sentry.target.getPosition(), $sentryAimOffset));
				}

				//shoot
				%sentry.setImageTrigger(0, 1);
				%sentry.setImageTrigger(0, 0);
			}
		}
	}
	
	if(sentryGroup.getCount() > 0)
	{
		$sentryLogicLoopSched = schedule($sentryLoopTime, 0, sentryLogicLoop);
	}
}

function serverCmdClearSentries(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		messageAll('', "\c2" @ %client.getPlayerName() SPC "\c3cleared all sentries.");

		for(%i = 0; %i < sentryGroup.getCount(); %i++)
		{
			sentryGroup.getObject(%i).sentryBottom.schedule(10, delete);
			sentryGroup.getObject(%i).schedule(10, delete);
		}
	}
}

function sentryChangeKit(%obj, %kit)
{
	if($sentryImage_[%kit @ "_1"] $= "")
	{
		return;
	}

	%obj.sentryXP = 0;
	%obj.sentryLevel = 1;
	%obj.sentryKit = %kit;
	%obj.unMountImage(0);
	%obj.mountImage($sentryImage_[%kit @ "_1"], 0);
}

if(!isObject(sentryBuildSound))
{
	datablock AudioProfile(sentryBuildSound)
	{
		fileName = "./sentryBuild.wav";
		description = AudioClose3d;
		preload = true;
	};
}

if(!isObject(toolboxPart2Debris))
{
	datablock DebrisData(toolboxPart2Debris)
	{
		shapeFile = "./toolboxgear.dts";
		lifetime = 2.8;
		spinSpeed = 1200;
		minSpinSpeed = -3600;
		maxSpinSpeed = 3600;
		elasticity = 0.5;
		friction = 0.2;
		numBounces = 3;
		staticOnMaxBounce = true;
		snapOnMaxBounce = false;
		fade = true;

		gravModifier = 4;
	};
}

if(!isObject(toolboxPart3Debris))
{
	datablock DebrisData(toolboxPart3Debris)
	{
		shapeFile = "./toolboxPart2.dts";
		lifetime = 4;
		spinSpeed = 200;
		minSpinSpeed = -300;
		maxSpinSpeed = 300;
		elasticity = 0.5;
		friction = 0.2;
		numBounces = 3;
		staticOnMaxBounce = true;
		snapOnMaxBounce = false;
		fade = true;

		gravModifier = 3;
	};
}

if(!isObject(toolboxPart4Debris))
{
	datablock DebrisData(toolboxPart4Debris)
	{
		shapeFile = "./toolboxPart1.dts";
		lifetime = 4;
		spinSpeed = 200;
		minSpinSpeed = -300;
		maxSpinSpeed = 300;
		elasticity = 0.5;
		friction = 0.2;
		numBounces = 4;
		staticOnMaxBounce = true;
		snapOnMaxBounce = false;
		fade = true;

		gravModifier = 2;
	};
}

if(!isObject(toolboxOpenExplosionParticle))
{
	datablock ParticleData(toolboxOpenExplosionParticle)
	{
		dragCoefficient		= 1;
		gravityCoefficient	= 0.4;
		inheritedVelFactor	= 0.2;
		constantAcceleration	= 0;
		lifetimeMS		= 2200;
		lifetimeVarianceMS	= 100;
		textureName		= "base/data/particles/cloud";
		spinSpeed		= 10;
		spinRandomMin		= -50;
		spinRandomMax		= 50;
		colors[0]		= "0.8 0.8 0.6 0.3";
		colors[1]		= "0.8 0.8 0.6 0";
		sizes[0]		= 6.25;
		sizes[1]		= 8.25;

		useInvAlpha		= true;
	};
}

if(!isObject(toolboxOpenExplosionEmitter))
{
	datablock ParticleEmitterData(toolboxOpenExplosionEmitter)
	{
		ejectionPeriodMS	= 1;
		periodVarianceMS	= 0;
		ejectionVelocity	= 4;
		velocityVariance	= 1;
		ejectionOffset  	= 0;
		thetaMin		= 89;
		thetaMax		= 90;
		phiReferenceVel		= 0;
		phiVariance		= 360;
		overrideAdvance		= false;
		particles		= toolboxOpenExplosionParticle;
	};
}

if(!isObject(toolboxOpenChunksParticle))
{
	datablock ParticleData(toolboxOpenChunksParticle)
	{
		dragCoefficient		= 1;
		gravityCoefficient	= 6;
		inheritedVelFactor	= 0.2;
		constantAcceleration	= 0;
		lifetimeMS		= 700;
		lifetimeVarianceMS	= 100;
		textureName		= "base/data/particles/nut";
		spinSpeed		= 790;
		spinRandomMin		= -790;
		spinRandomMax		= 790;
		colors[0]		= "0.4 0.2 0 0.6";
		colors[1]		= "0.4 0.2 0 0";
		sizes[0]		= 0.7;
		sizes[1]		= 0.6;

		useInvAlpha		= false;
	};
}

if(!isObject(toolboxOpenChunksEmitter))
{
	datablock ParticleEmitterData(toolboxOpenChunksEmitter)
	{
		lifeTimeMS		= 100;
		ejectionPeriodMS	= 6;
		periodVarianceMS	= 0;
		ejectionVelocity	= 12;
		velocityVariance	= 12;
		ejectionOffset		= 1;
		thetaMin		= 0;
		thetaMax		= 180;
		phiReferenceVel		= 0;
		phiVariance		= 360;
		overrideAdvance		= false;
		particles		= toolboxOpenChunksParticle;
	};
}

if(!isObject(toolboxOpenSprayParticle))
{
	datablock ParticleData(toolboxOpenSprayParticle)
	{
		dragCoefficient		= 0.2;
		gravityCoefficient	= 5;
		inheritedVelFactor	= 0.2;
		constantAcceleration	= 0;
		lifetimeMS		= 1000;
		lifetimeVarianceMS	= 200;
		textureName		= "base/data/particles/chunk";
		spinSpeed		= 900;
		spinRandomMin		= -900;
		spinRandomMax		= 900;
		colors[0]		= "0.27 0.1 0 1";
		colors[1]		= "0.27 0.1 0 1";
		colors[2]		= "0.27 0.1 0 0";
		sizes[0]		= 0.8;
		sizes[1]		= 0.8;
		sizes[2]		= 0;
		useInvAlpha		= false;
	};
}

if(!isObject(toolboxOpenSprayEmitter))
{
	datablock ParticleEmitterData(toolboxOpenSprayEmitter)
	{
		lifeTimeMS		= 100;
		ejectionPeriodMS	= 1;
		periodVarianceMS	= 0;
		ejectionVelocity	= 18;
		velocityVariance	= 18;
		ejectionOffset		= 1;
		thetaMin		= 0;
		thetaMax		= 180;
		phiReferenceVel		= 0;
		phiVariance		= 360;
		overrideAdvance		= false;
		particles		= toolboxOpenSprayParticle;
	};
}

if(!isObject(toolboxOpenDebris1Explosion))
{
	datablock ExplosionData(toolboxOpenDebris1Explosion)
	{
		particleEmitter = toolboxOpenChunksEmitter;
		particleDensity = 4;
		particleRadius = 0.2;

		debris = toolboxPart2Debris;
		debrisNum = 8;
		debrisNumVariance = 6;
		debrisPhiMin = 0;
		debrisPhiMax = 360;
		debrisThetaMin = 0;
		debrisThetaMax = 180;
		debrisVelocity = 12;
		debrisVelocityVariance = 6;
	};
}

if(!isObject(toolboxOpenDebris2Explosion))
{
	datablock ExplosionData(toolboxOpenDebris2Explosion)
	{
		debris = toolboxPart3Debris;
		debrisNum = 1;
		debrisNumVariance = 0;
		debrisPhiMin = 0;
		debrisPhiMax = 360;
		debrisThetaMin = 0;
		debrisThetaMax = 180;
		debrisVelocity = 16;
		debrisVelocityVariance = 6;
	};
}

if(!isObject(toolboxExplosionExplosion))
{
	datablock ExplosionData(toolboxExplosionExplosion)
	{
		explosionShape = "";

		lifeTimeMS = 150;

		debris = toolboxPart4Debris;
		debrisNum = 1;
		debrisNumVariance = 0;
		debrisPhiMin = 0;
		debrisPhiMax = 360;
		debrisThetaMin = 0;
		debrisThetaMax = 180;
		debrisVelocity = 16;
		debrisVelocityVariance = 6;

		particleEmitter = toolboxOpenExplosionEmitter;
		particleDensity = 10;
		particleRadius = 0.2;

		emitter[0] = toolboxOpenSprayEmitter;
		emitter[1] = toolboxOpenStreakEmitter;
		emitter[2] = toolboxOpenChunksEmitter;

		subExplosion[0] = toolboxOpenDebris1Explosion;
		subExplosion[1] = toolboxOpenDebris2Explosion;

		faceViewer	  = true;
		explosionScale = "1 1 1";

		shakeCamera = true;
		camShakeFreq = "10 11 10";
		camShakeAmp = "3 10 3";
		camShakeDuration = 0.1;
		camShakeRadius = 20;
	};
}

if(!isObject(toolboxExplosion))
{
	datablock ExplosionData(toolboxExplosion)
	{
		explosionShape = "";

		lifeTimeMS = 150;

		particleEmitter = toolboxOpenExplosionEmitter;
		particleDensity = 10;
		particleRadius = 0.2;

		emitter[0] = toolboxOpenSprayEmitter;
		emitter[1] = toolboxOpenStreakEmitter;
		emitter[2] = toolboxOpenChunksEmitter;

		faceViewer	  = true;
		explosionScale = "1 1 1";

		shakeCamera = true;
		camShakeFreq = "10 11 10";
		camShakeAmp = "3 10 3";
		camShakeDuration = 0.1;
		camShakeRadius = 20;
	};
}

if(!isObject(toolboxExplosionProjectile))
{
	datablock ProjectileData(toolboxExplosionProjectile)
	{
		uiName		= "";

		lifetime	= 10;
		fadeDelay	= 10;
		explodeondeath	= true;
		explosion	= toolboxExplosionExplosion;
	};
}

if(!isObject(toolboxExplosion2Projectile))
{
	datablock ProjectileData(toolboxExplosion2Projectile)
	{
		uiName		= "";

		lifetime	= 10;
		fadeDelay	= 10;
		explodeondeath	= true;
		explosion	= toolboxExplosion;
	};
}

if(!isObject(toolboxBBBeepParticle))
{
	datablock ParticleData(toolboxBBBeepParticle)
	{
		dragCoefficient		= 1;
		gravityCoefficient	= 0.4;
		inheritedVelFactor	= 0.2;
		constantAcceleration	= 0;
		lifetimeMS		= 800;
		lifetimeVarianceMS	= 200;
		textureName		= "base/data/particles/thinRing";
		spinSpeed		= 10;
		spinRandomMin		= -50;
		spinRandomMax		= 50;
		colors[0]		= "1 1 1 0.8";
		colors[1]		= "1 1 1 0";
		sizes[0]		= 15.25;
		sizes[1]		= 17.25;

		useInvAlpha = true;
	};
}

if(!isObject(toolboxBBBeepEmitter))
{
	datablock ParticleEmitterData(toolboxBBBeepEmitter)
	{
		ejectionPeriodMS	= 1;
		periodVarianceMS	= 0;
		ejectionVelocity	= 4;
		velocityVariance	= 1;
		ejectionOffset  	= 0;
		thetaMin		= 89;
		thetaMax		= 90;
		phiReferenceVel		= 0;
		phiVariance		= 360;
		overrideAdvance		= false;
		particles		= toolboxBBBeepParticle;
	};
}

if(!isObject(sentryExplosion))
{
	datablock ExplosionData(sentryExplosion)
	{
		explosionShape = "";

		lifeTimeMS = 150;

		particleEmitter = toolboxBBBeepEmitter;
		particleDensity = 10;
		particleRadius = 0.2;

		faceViewer	  = true;
		explosionScale = "1 1 1";

		shakeCamera = false;
		camShakeFreq = "10 11 10";
		camShakeAmp = "3 10 3";
		camShakeDuration = 0.1;
		camShakeRadius = 20;
	};
}