function serverCmdNextPhase(%client)
{
	serverCmdForcePhase(%client);
}

function serverCmdForcePhase(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!%client.isSuperAdmin)
	{
		messageClient(%client, '', "You must be a \c6Super Admin\c0 to use this command.");

		return;
	}

	%var = !%mini.phase ? "fighting" : "building";
	warn(%client.getPlayerName() SPC "Forced the next phase. The phase is now a" SPC %var SPC "phase.");
	%mini.messageAll('', "\c6" @ %client.getPlayerName() SPC "\c0Forced the next phase. The phase is now a\c6" SPC %var SPC "\c0phase.");

	%mini.phaseTime = 0;
	%mini.phaseCounter();
}

function serverCmdPause(%client)
{
	serverCmdPausePhase(%client);
}

function serverCmdPausePhase(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!%client.isSuperAdmin)
	{
		messageClient(%client, '', "You must be a \c6Super Admin\c0 to use this command.");

		return;
	}

	if(isEventPending(%mini.phaseSchedule))
	{
		cancel(%mini.phaseSchedule);

		warn(%client.getPlayerName() SPC "Paused the phase.");
		%mini.messageAll('', "\c6" @ %client.getPlayerName() SPC "\c0Paused the phase.");
	}

	else
	{
		%mini.phaseSchedule = %mini.schedule(1000, phaseCounter);

		warn(%client.getPlayerName() SPC "resumed the phase.");
		%mini.messageAll('', "\c6" @ %client.getPlayerName() SPC "\c0Resumed the phase.");
	}
}

function serverCmdClearAllDroppedMoney(%client)
{
	//Clears all dropped Base Raiders Money in the server.

	serverCmdClearDroppedMoney(%client, 1);
}

function serverCmdClearDroppedMoney(%client, %bool)
{
	//Clears all dropped Base Raiders money in the minigame.

	if(!%bool && !%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!%client.isSuperAdmin)
	{
		messageClient(%client, '', "You must be a \c6Super Admin\c0 to use this command.");

		return;
	}

	for(%i = 0; %i < missionCleanup.getCount(); %i++)
	{
		%obj = missionCleanup.getObject(%i);

		if(%obj.getClassName() !$= "item" || %obj.getDataBlock().getName() !$= "BaseRaidersCashItem")
		{
			continue;
		}

		if(!%bool && %obj.minigame != %mini)
		{
			continue;
		}

		%obj.schedule(0, delete);
	}

	if(%bool)
	{
		warn(%client.getPlayerName() SPC "cleared all dropped money in the server.");
		messageAll('', "\c3" @ %client.getPlayerName() SPC "\c0cleared all dropped money in the server.");
	}

	else
	{
		warn(%client.getPlayerName() SPC "cleared all dropped money in their mingame.");
		%mini.messageAll('', "\c3" @ %client.getPlayerName() SPC "\c2cleared all dropped money \c3in the minigame\c2.");
	}
}

function serverCmdClearAllBarricades(%client)
{
	serverCmdClearBarricades(%client, 1);
}

function serverCmdClearBarricades(%client, %bool)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!%client.isSuperAdmin)
	{
		messageClient(%client, '', "You must be a \c6Super Admin\c0 to use this command.");

		return;
	}

	$BaseRaiders::BuildingPhaseClear = "";

	for(%i = 0; %i < mainBrickGroup.getCount(); %i++)
	{
		%bg = mainBrickGroup.getObject(%i);

		if(!%bg.getCount() || (getMiniGameFromObject(%bg) != %mini && !%bool))
		{
			continue;
		}

		%bg.chain_batchSize = 125;
		%bg.chain_timeOut = 25;
		%bg.chain_callback = "doneWithAdminBarricadeDeleteJunk";
		%bg.chainMethodCall("doAdminBarricadeDeleteJunk", 1);
	}

	if(%bool)
	{
		warn(%client.getPlayerName() SPC "cleared all barricades in the server.");
		messageAll('', "\c3" @ %client.getPlayerName() SPC "\c0cleared all barricades in the server.");
	}

	else
	{
		warn(%client.getPlayerName() SPC "cleared all barricades in their minigame.");
		%mini.messageAll('', "\c3" @ %client.getPlayerName() SPC "\c0cleared all barricades \c3in the minigame\c2.");
	}
}

function fxDTSBrick::doAdminBarricadeDeleteJunk(%brick, %bool)
{
	if(%bool || (isObject(%mini = getMiniGameFromObject(%brick)) && isObject(%mini.gameMode) && %mini.gameMode.class $= "BaseRaiders"))
	{
		%data = %brick.getDataBlock();

		if(%brick.getGroup() != BrickGroup_888888.getID() && (%data.baseRaidersBrickType $= "" || %data.baseRaidersBrickType == 1))
		{
			%brick.onDeath();
			%brick.delete();
		}
	}
}

function simGroup::doneWithAdminBarricadeDeleteJunk(%obj)
{
	if(!%obj.getCount() && %obj.isGang == -1)
	{
		%obj.delete();
	}
}

function serverCmdHeightInPlates(%client)
{
	if(!%client.isSuperAdmin)
	{
		messageClient(%client, '', "You must be a \c6Super Admin\c0 to use this command.");

		return;
	}

	if(!isObject(%player = %client.player))
	{
		return;
	}

	%height = getWord(%player.getPosition(), 2) / 0.2;

	if(strStr(%height, ".") != -1)
	{
		%decimals = getSubStr(%height, strStr(%height, ".") + 1, strLen(%height) - (strStr(%height, ".") + 1));
		%decimals = getSubStr(%decimals, 0, 1);

		%height = mFloor(%height);
		%height = %height @ "." @ %decimals;
	}

	%about = %height == mFloor(%height) ? "" : "\c6about\c3 ";
	%height = mFloor(%height);

	commandToClient(%client, 'centerPrint', "\c6Your height in plates:\c3" SPC %about @ %height @ "\c6.", 3);
}