//==================================================
// List of gang commands and alt commands.
//==================================================
//		/listGangs - Anyone
//	/listTeams
//
//
//		/makeGang [NAME] - Anyone
//	/createGang [NAME]
//	/startGang [NAME]
//
//
//		/renameGang [NAME] - Commander and above.
//
//
//		/disbandGang - Owner only.
//	/destroyGang
//	/removeGang
//
//
//		/invite [NAME] - Colonels and above.
//	/inviteToGang [NAME]
//
//
//		/cancelInvite - Colonels and above.
//	/cancelGangInvite
//
//
//		/joinGang - Anyone.
//	/join
//	/accept
//	/acceptGang
//
//
//		/declineGang - Anyone.
//	/decline
//	/declineGangInvite
//
//
//		/gangKick [NAME OR BL_ID(if they're not on the server)] - Commanders and above.
//	/kickGang [NAME OR BL_ID(if they're not on the server)]
//	/kickFromGang [NAME OR BL_ID(if they're not on the server)]
//
//
//		/leaveGang - Anyone.
//	/leave
//
//
//		/setGangRank [NAME OR BL_ID(if they're not on the server)] [RANK] - Owner only.
//	/setRank [NAME OR BL_ID(if they're not on the server)] [RANK]
//
//
//		/gang [Optional: PLAYER NAME] - Anyone.
//	/viewGang [Optional: PLAYER NAME]
//	/checkGang [Optional: PLAYER NAME]
//
//
//		/makeDoor [Optional: TIME(MS)] - Anyone.
//
//
//		/unMakeDoor - Anyone.
//	/makeDoor 0
//	/makeDoor -1
//==================================================
function serverCmdListGangs(%client)
{
	serverCmdListTeams(%client);
}

function serverCmdCreateGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11)
{
	serverCmdMakeGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11);
}

function serverCmdStartGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11)
{
	serverCmdMakeGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11);
}

function serverCmdMakeGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(isObject(%client.gangBricks))
	{
		messageClient(%client, '', "You're already in the\c6" SPC %client.gang.name SPC "gang!" NL "Use \c6/leaveGang\c0 to leave your gang.");

		return;
	}

	%name = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11);

	if(strReplace(%name, " ", "") $= "")
	{
		messageClient(%client, '', "No blank gang names allowed.");

		return;
	}

	if(strLen(%name) > $BaseRaiders::Gangs::MaxNameLength)
	{
		messageClient(%client, '', "Too many charaters in gang name! The maximum is\c6" SPC $BaseRaiders::Gangs::MaxNameLength @ "\c0.");

		%name = getSubStr(%name, 0, $BaseRaiders::Gangs::MaxNameLength - 1);
	}

	if(%name !$= stripChars(%name, $BaseRaiders::Gangs::RestrictedChars))
	{
		messageClient(%client, '', "Restricted characters in gang name!" NL "Restricted chars:\c6" SPC $BaseRaiders::Gangs::RestrictedChars);

		return;
	}

	%list = strReplace($BaseRaiders::Gangs::RestrictedWords, ",", "\t");

	for(%i = 0; %i < getFieldCount(%list); %i++)
	{
		if(strStr(strLwr(%name), strLwr(getField(%list, %i))) != -1)
		{
			messageClient(%client, '', "Restricted word(s) in gang name!" NL "Restricted words:\c6" SPC $BaseRaiders::Gangs::RestrictedWords);

			return;
		}
	}

	for(%i = 0; %i < mainBrickGroup.getCount(); %i++)
	{
		%group = mainBrickGroup.getObject(%i);

		if(%group.isGang && %name $= %group.name)
		{
			messageClient(%client, '', "There is already a gang with the name \"\c6" @ %name @ "\c0\"!");

			return;
		}
	}

	%groupName = "BrickGroup_Gang_" @ strReplace(%name, " ", "_");

	%group = new simGroup(%groupName)
	{
		abandonedTime = 0;
		bl_id = %client.getBLID();
		client = %client;
		doNotDelete = 1;
		isAdmin = 0;
		isPublicDomain = 0;
		name = %name;
		NTObjectCount = 0;
		quotaObject = GlobalQuota;

		trust[%client.getBLID()] = 2;

		isGang = 1;
		gangMember[0] = %client.getBLID() TAB %client.getPlayerName() TAB %client TAB "3";
		numGangMembers = 1;
	};

	if(!isObject(%group))
	{
		error("Something went wrong in gang group creation!");

		return;
	}

	mainBrickGroup.add(%group);

	%team = %mini.teams.addTeam();
	%team.template = %mini.gameMode.template.getObject(0);
	%team.template.locked_name = %name;
	%team.template.locked_color = %mini.colorIDX;
	%team.template.locked_maxPlayers = %mini.baseRaidersMaxGangMembers;
	%mini.gameMode.applyDefaultTeamPreferences(%team, %team.template);
	%team.template.locked_name = "";
	%team.template.locked_colorIDX = 45;
	%team.template.locked_maxPlayers = "";

	%team.isGang = 1;

	%team.gangBricks = %group;
	%group.gangTeam = %team;

	%client.gangBricks = %group;
	%client.gangTeam = %team;
	%client.brickGroup = %group;

	%team.addMember(%client, "Make Gang", 1);

	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		%sentry = sentryGroup.getObject(%i);

		if(isObject(%sentry.sentryOwner) && %sentry.sentryOwner == %client)
		{
			%sentry.slyrTeam = %team;
			%sentry.sentryBottom.slyrTeam = %team;
		}
	}

	%mini.messageAll('', "\c7The gang" SPC %name SPC "has risen.");

	if(isObject(%formerBG = "BrickGroup_" @ %client.getBLID()) && %formerBG.getCount())
	{
		%formerBG.chain_batchSize = 125;
		%formerBG.chain_timeout = 25;
		%formerBG.chain_callback = "";
		%formerBG.chainMethodCall("transferBrickToGroup", %group);
	}
}

function fxDTSBrick::transferBrickToGroup(%brick, %group)
{
	if(!isObject(%group) || %group.getClassName() !$= "simGroup")
	{
		return;
	}

	%group.add(%brick);
}

function serverCmdRenameGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%client.gangBricks))
	{
		messageClient(%client, '', "You must be in a gang to use this command!");

		return;
	}

	if(%client.getGangRank() < 2)
	{
		messageClient(%client, '', "Only \c6Commanders\c0 and above can use this command!");

		return;
	}

	%name = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11);

	if(strReplace(%name, " ", "") $= "")
	{
		messageClient(%client, '', "No blank gang names allowed.");

		return;
	}

	if(strLen(%name) > $BaseRaiders::Gangs::MaxNameLength)
	{
		messageClient(%client, '', "Too many charaters in gang name! The maximum is\c6" SPC $BaseRaiders::Gangs::MaxNameLength @ "\c0.");

		%name = getSubStr(%name, 0, $BaseRaiders::Gangs::MaxNameLength - 1);
	}

	if(%name !$= stripChars(%name, $BaseRaiders::Gangs::RestrictedChars))
	{
		messageClient(%client, '', "Restricted characters in gang name!" NL "Restricted chars:\c6" SPC $BaseRaiders::Gangs::RestrictedChars);

		return;
	}

	%list = strReplace($BaseRaiders::Gangs::RestrictedWords, ",", "\t");

	for(%i = 0; %i < getFieldCount(%list); %i++)
	{
		if(strStr(%name, getField(%list, %i)) != -1)
		{
			messageClient(%client, '', "Restricted word(s) in gang name!" NL "Restricted words:\c6" SPC $BaseRaiders::Gangs::RestrictedWords);

			return;
		}
	}

	for(%i = 0; %i < mainBrickGroup.getCount(); %i++)
	{
		%group = mainBrickGroup.getObject(%i);

		if(%group.isGang && %name $= %group.name)
		{
			messageClient(%client, '', "There is already a gang with the name \"\c6" @ %name @ "\c0\"!");

			return;
		}
	}

	%mini.messageAll('', "\c7" @ %client.getPlayerName() SPC "has changed the name of their gang from \"" @ %client.gangBricks.name @ "\" to \"" @ %name @ "\".");

	%client.gangBricks.setName("BrickGroup_Gang_" @ strReplace(%name, " ", ""));
	%client.gangBricks.name = %name;
}

function serverCmdDestroyGang(%client)
{
	serverCmdDisbandGang(%client);
}

function serverCmdRemoveGang(%client)
{
	serverCmdDisbandGang(%client);
}

function serverCmdDisbandGang(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%group = %client.gangBricks))
	{
		messageClient(%client, '', "You must be in a gang to use this command!");

		return;
	}

	if(%client.getGangRank() < 3)
	{
		messageClient(%client, '', "Only the gang \c6Owner\c0 can use this command!");

		return;
	}

	%mini.messageAll('', "\c7" @ %client.getPlayerName() SPC "has disbanded the gang \"" @ %group.name @ "\"");

	%group.gangTeam.removeAllMembers();
	%group.gangTeam.delete();
	%group.gangTeam = -1;

	for(%i = 0; %i < %group.numGangMembers; %i++)
	{
		%member = %group.gangMember[%i];
		%c = getField(%member, 2);
		%bl_id = isObject(%c) ? %c.getBLID() : getField(%member, 0);

		%group.trust[%bl_id] = 0;
		%group.gangMember[%i] = "";

		if(isObject(%c))
		{
			messageClient(%c, '', "\c7You're no longer a member of the gang \"" @ %group.name @ "\" because it's been disbanded.");

			if(%c.brickGroup.getName() != "BrickGroup_" @ %c.getBLID())
			{
				%c.brickGroup = "BrickGroup_" @ %c.getBLID();
			}

			if(%c.gangBricks == %group)
			{
				%c.gangBricks = -1;
			}

			if(%c.minigame == %client.minigame && %c.gangTeam == %client.gangTeam)
			{
				%c.gangTeam = -1;
			}
		}
	}

	%group.numGangMembers = 0;
	%group.isGang = -1;
	%group.client = -1;
	%group.bl_id = 777777;
	%group.setName("BrickGroup_GangRemains_" @ getRandom(0, 999999));
	%group.name = "Gang Remnants";

	if($BaseRaiders::Gangs::ClearBricksOnDisband)
	{
		$BaseRaiders::BuildingPhaseClear = addItemToList($BaseRaiders::BuildingPhaseClear, %group);
	}
}

function serverCmdInviteToGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12)
{
	serverCmdInvite(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12);
}

function serverCmdInvite(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%client.gangBricks))
	{
		messageClient(%client, '', "You're not in a gang!");

		return;
	}

	if(%client.getGangRank() < 1)
	{
		messageClient(%client, '', "Only \c6Colonels\c0 and above can use this command!");

		return;
	}

	if(%client.gangBricks.numGangMembers >= %mini.baseRaidersMaxGangMembers)
	{
		messageClient(%client, '', "You can only have up to\c6" SPC %mini.baseRaidersMaxGangMembers SPC "\c0members in a gang! Use /gangKick NAME(or BL ID) to kick someone out of your gang.");

		return;
	}

	%target = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11 SPC %word12);
	%target = findClientByName(%target);

	if(!isObject(%target))
	{
		messageClient(%client, '', "No one with that name found!");

		return;
	}

	if(%target == %client)
	{
		messageClient(%client, '', "You can't invite yourself to the gang you're already in!");

		return;
	}

	if(!isObject(%target.minigame) || %target.minigame != %mini)
	{
		messageClient(%client, '', %target.getPlayerName() SPC "isn't in the same minigame as you!");

		return;
	}

	if(isObject(%target.gangBricks))
	{
		%var = %target.gangBricks == %client.gangBricks ? "your" : "a";
		messageClient(%client, '', %target.getPlayerName() SPC "is already in" SPC %var SPC "gang!");

		return;
	}

	if(%target.gangInvite !$= "" && isObject(firstWord(%target.gangInvite)))
	{
		if(firstWord(%target.gangInvite) $= %client.gangBricks)
		{
			%var = "your";
			%var2 = " again";
		}

		else
		{
			%var = "a";
			%var2 = "";
		}

		messageClient(%client, '', "\c6" @ %target.getPlayerName() SPC "\c0has already been invited to" SPC %var SPC "gang." NL "You must wait at least\c6" SPC 15 - ($Sim::Time - getWord(%target.gangInvite, 1)) SPC "\c0seconds to invite them" @ %var2 @ ".");

		return;
	}

	%client.gangBricks.messageGang('', "\c7" @ %client.getPlayerName() SPC "has succesfully sent an invitation to" SPC %target.getPlayerName() SPC "to join the gang.");

	messageClient(%target, '', "\c7You've recieved an invitation to join the gang \"" SPC %client.gangBricks.name @ "\"." NL "You have 15 second to use /joinGang or /decline to respond.");
	%target.gangInvite = %client.gangBricks SPC $Sim::Time SPC %client;

	%target.schedule(15000, nullGangInvite);
}

function gameConnection::nullGangInvite(%client)
{
	%client.gangInvite = "";
}

function serverCmdCancelGangInvite(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12)
{
	serverCmdCancelInvite(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12);
}

function serverCmdCancelInvite(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%client.gangBricks))
	{
		messageClient(%client, '', "You're not in a gang!");

		return;
	}

	if(%client.getGangRank() < 1)
	{
		messageClient(%client, '', "Only \c6Colonels\c0 and above can use this command!");

		return;
	}

	%target = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11 SPC %word12);
	%target = findClientByName(%target);

	if(!isObject(%target))
	{
		messageClient(%client, '', "No one with that name found!");

		return;
	}

	if(%target == %client)
	{
		return;
	}

	if(!isObject(%target.minigame) || %target.minigame != %mini)
	{
		messageClient(%client, '', %target.getPlayerName() SPC "isn't in the same minigame as you!");

		return;
	}

	if(isObject(%target.gangBricks))
	{
		return;
	}

	if(%target.gangInvite $= "" || firstWord(%target.gangInvite) != %client.gangBricks)
	{
		messageClient(%client, '', "\c7" @ %target.getPlayerName() SPC "doesn't have a gang invite from your gang.");

		return;
	}

	%var = getSubStr(%target.getPlayerName(), strLen(%target.getPlayerName() - 1), 1) $= "s" ? %target.getPlayerName() @ "'" : %target.getPlayerName() @ "'s";

	%client.gangBricks.messageGang('', "\c7" @ %var SPC "invitation to your gang has been canceled by" SPC %client.getPlayerName() @ ".");

	messageClient(%target, '', "\c7Your gang invitation to join the gang \"" @ %client.gangBricks.name @ "\" has been canceled by one of the gang members.");
	%target.gangInvite = "";
}

function serverCmdJoin(%client)
{
	serverCmdJoinGang(%client);
}

function serverCmdAccept(%client)
{
	serverCmdJoinGang(%client);
}

function serverCmdAcceptGang(%client)
{
	serverCmdJoinGang(%client);
}

function serverCmdJoinGang(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(%client.gangInvite $= "")
	{
		messageClient(%client, '', "You don't have a pending gang invite!");

		return;
	}

	if(!isObject(%gangBricks = firstWord(%client.gangInvite)))
	{
		messageClient(%client, '', "The gang you were invited to no longer exists!");
		%client.gangInvite = "";

		return;
	}

	if(%gangBricks.numGangMembers >= %mini.baseRaidersMaxGangMembers)
	{
		messageClient(%client, '', "The gang you were invited to was filled before you could join it!");
		%client.gangInvite = "";

		return;
	}

	if($Sim::Time - getWord(%client.gangInvite, 1) > 15)
	{
		messageClient(%client, '', "You didn't respond to your pending gang invite fast enough!");
		%client.gangInvite = "";

		return;
	}

	%gangBricks.gangMember[%gangBricks.numGangMembers] = %client.getBLID() TAB %client.getPlayerName() TAB %client TAB "0";
	%gangBricks.numGangMembers++;
	%gangBricks.trust[%client.getBLID()] = 2;
	%gangBricks.gangTeam.addMember(%client, "Invited", 1);

	%client.brickGroup = %gangBricks;
	%client.gangBricks = %gangBricks;
	%client.gangTeam = %gangBricks.gangTeam;
	%client.gangInvite = "";

	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		%sentry = sentryGroup.getObject(%i);

		if(isObject(%sentry.sentryOwner) && %sentry.sentryOwner == %client)
		{
			if(isObject(%sentry.sentryBottom))
			{
				%sentry.sentryBottom.delete();
			}

			%sentry.delete();
		}
	}

	//Add all the bricks from the target's brick group to the gang's brick group, in case they planted bricks while not in any gang. Might not do.
}

function serverCmdDecline(%client)
{
	serverCmdDeclineGang(%client);
}

function serverCmdDeclineGangInvite(%client)
{
	serverCmdDeclineGang(%client);
}

function serverCmdDeclineGang(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");
		%client.gangInvite = "";

		return;
	}

	if(%client.gangInvite $= "")
	{
		messageClient(%client, '', "You don't have a pending gang invite!");

		return;
	}

	if(!isObject(%gangBricks = firstWord(%client.gangInvite)))
	{
		messageClient(%client, '', "The gang you were invited to no longer exists!");
		%client.gangInvite = "";

		return;
	}

	%gangBricks.messageGang('', "\c7" @ %client.getPlayerName() SPC "has denied an invitation to join your gang.");

	messageClient(%client, '', "You've denied an invitation to join the \"\c6" @ %gangBricks.name @ "\c0\" gang.");
	%client.gangInvite = "";
}

function serverCmdKickGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12)
{
	serverCmdGangKick(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12);
}

function serverCmdKickFromGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12)
{
	serverCmdGangKick(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12);
}

function serverCmdGangKick(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%group = %client.gangBricks))
	{
		messageClient(%client, '', "You're not in a gang!");

		return;
	}

	if(%client.getGangRank() < 2)
	{
		messageClient(%client, '', "Only \c6Commanders\c0 and above can use this command!");

		return;
	}

	if(%client.gangBricks.numGangMembers <= 1)
	{
		messageClient(%client, '', "There's no one else in your gang to kick!");

		return;
	}

	%words = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11 SPC %word12);
	%target = findClientByName(%words);

	if(!isObject(%target))
	{
		%target = findClientByBL_ID(%words);
	}

	if(%target == %client)
	{
		messageClient(%client, '', "You can't kick yourself from your own gang!" NL "Use \c6/leaveGang\c0 if you wish to leave your gang.");

		return;
	}

	%found = -1;

	for(%i = 0; %i < %group.numGangMembers; %i++)
	{
		%member = %group.gangMember[%i];

		if(isObject(%target) && getField(%member, 0) != %target.getBLID())
		{
			continue;
		}

		else if(!isObject(%target) && getField(%member, 0) !$= %words)
		{
			continue;
		}

		if(getField(%member, 3) >= %client.getGangRank())
		{
			%name = isObject(%target) ? %target.getPlayerName() : getField(%member, 1);
			%bl_id = isObject(%target) ? %target.getBLID() : getField(%member, 0);

			messageClient(%client, '', "\c6" @ %name SPC "\c0is too high of a rank for you to kick from the gang!");

			return;
		}

		%found = %i;
		break;
	}

	if(%found == -1)
	{
		messageClient(%client, '', "No one with that name or BL ID is in your gang!");

		return;
	}

	%group.trust[%bl_id] = 0;
	%group.gangMember[%found] = "";

	if(%found != %group.numGangMembers - 1)
	{
		for(%i = %found + 1; %i < %group.numGangMembers; %i++)
		{
			%group.gangMember[%i - 1] = %group.gangMember[%i];
			%group.gangMember[%i] = "";
		}
	}

	%group.numGangMembers--;

	if(isObject(%target))
	{
		if(%target.brickGroup.getName() !$= "BrickGroup_" @ %target.getBLID())
		{
			%target.brickGroup = "BrickGroup_" @ %target.getBLID();
		}

		if(%target.gangBricks == %group)
		{
			%target.gangBricks = -1;
		}

		if(%target.minigame == %client.minigame && %target.gangTeam == %client.gangTeam)
		{
			%client.gangTeam.removeMember(%target, "Gang Kick", 1);
			%target.gangTeam = -1;
		}
	}

	%mini.messageAll('', "\c7" @ %client.getPlayerName() SPC "has kicked" SPC %name SPC "from the gang \"" @ %group.name @ "\"");
}

function serverCmdLeave(%client)
{
	serverCmdLeaveGang(%client);
}

function serverCmdLeaveGang(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%group = %client.gangBricks))
	{
		messageClient(%client, '', "You're not in a gang!");

		return;
	}

	if(%group.numGangMembers <= 1)
	{
		serverCmdDisbandGang(%client);

		return;
	}

	if(isObject(%client.gangTeam))
	{
		%client.gangTeam.removeMember(%client, "Leave Gang", 1);
	}

	%client.brickGroup = "BrickGroup_" @ %client.getBLID();

	%client.gangTeam = -1;
	%client.gangBricks = -1;

	%group.trust[%client.getBLID()] = 0;

	%found = -1;

	for(%i = 0; %i < %group.numGangMembers; %i++)
	{
		if(getField(%group.gangMember[%i], 0) == %client.getBLID())
		{
			%group.gangMember[%i] = "";

			%found = %i;
			break;
		}
	}

	if(%found == -1)
	{
		return;
	}

	for(%i = %found + 1; %i < %group.numGangMembers; %i++)
	{
		%group.gangMember[%i - 1] = %group.gangMember[%i];
		%group.gangMember[%i] = "";
	}

	%client.gangBricks.numGangMembers--;
}

function serverCmdSetRank(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	serverCmdSetGangRank(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13);
}

function serverCmdSetGangRank(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%group = %client.gangBricks))
	{
		messageClient(%client, '', "You're not in a gang!");

		return;
	}

	if(%client.getGangRank() < 3)
	{
		messageClient(%client, '', "Only the gang \c6Owner\c0 can use this command!");

		return;
	}

	if(%client.gangBricks.numGangMembers <= 1)
	{
		messageClient(%client, '', "There's no one else in your gang to change the rank of!");

		return;
	}

	%words = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11 SPC %word12 SPC %word13);

	if(%words $= "")
	{
		messageClient(%client, '', "Useage: /\c6setGangRank\c0 [\c6RANK\c0] [\c6NAME\c0]");

		return;
	}

	%rank = getWord(%words, getWordCount(%words) - 1);
	%words = getWords(%words, 0, getWordCount(%words) - 2);
	%target = %words;

	switch$(%rank)
	{
		case "Member":
			%rank = 0;

		case "Colonel":
			%rank = 1;

		case "Commander":
			%rank = 2;

		case "Owner":
			%rank = 3;
	}

	%target = findClientByName(%target);

	if(!isObject(%target))
	{
		%target = findClientByBL_ID(%words);
	}

	if(%target == %client)
	{
		messageClient(%client, '', "You can't change your own rank!" NL "Set someone else's rank to \c6Owner\c0 if you don't wish to own the gang anymore.");

		return;
	}

	%found = -1;

	for(%i = 0; %i < %group.numGangMembers; %i++)
	{
		%member = %group.gangMember[%i];
		%name = isObject(%target) ? %target.getPlayerName() : getField(%member, 1);

		if(isObject(%target) && getField(%member, 0) != %target.getBLID())
		{
			continue;
		}

		else if(!isObject(%target) && getField(%member, 0) !$= %words)
		{
			continue;
		}

		if(getField(%member, 3) == %rank)
		{
			messageClient(%client, '', "\c6" @ %name SPC "\c0is already a\c6" SPC getGangRankName(getField(%member, 3)) @ "\c0.");

			return;
		}

		%found = %i;
		break;
	}

	if(%found == -1)
	{
		messageClient(%client, '', "No one with that name or BL ID is in your gang!");

		return;
	}

	%var = %rank > getField(%group.gangMember[%found], 3) ? "promoted" : "demoted";

	%group.messageGang('', "\c7" @ %client.getPlayerName() SPC "has" SPC %var SPC %name SPC "to the rank of" SPC getGangRankName(%rank) @ ".");

	%group.gangMember[%found] = setField(%group.gangMember[%found], 3, %rank);

	if(%rank >= 3)
	{
		%group.bl_id = %target.getBLID();
		%group.client = %target;

		for(%i = 0; %i < %group.numGangMembers; %i++)
		{
			%member = %group.gangMember[%i];

			if(getField(%member, 0) == %client.getBLID())
			{
				%group.gangMember[%i] = setField(%member, 3, "2");

				break;
			}
		}

		%group.messageGang('', "\c7" @ %client.getPlayerName() SPC "has automatically been demoted to the rank of" SPC getGangRankName(2) @ ".");
	}
}

function serverCmdViewGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	serverCmdGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13);
}

function serverCmdCheckGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	serverCmdGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13);
}

function serverCmdGang(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	%target = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11 SPC %word12 SPC %word13);
	%target = %target !$= "" ? findClientByName(%target) : %client;

	if(!isObject(%target))
	{
		messageClient(%client, '', "No one with that name found!");

		return;
	}

	if(%target.minigame != %client.minigame)
	{
		messageClient(%client, '', %target.getPlayerName() SPC "isn't in the same minigame as you!");

		return;
	}

	if(!isObject(%group = %target.gangBricks))
	{
		%var = %target == %client ? "\c6You\c0 aren't" : "\c6" @ %target.getPlayerName() SPC "\c0isn't";
		messageClient(%client, '', %var SPC "in a gang!");

		return;
	}

	%msg = "\c6Gang:\c3" SPC %target.gangBricks.name SPC "\c6|" SPC "Members:\c3" SPC %group.numGangMembers SPC "\c6|";

	for(%i = 0; %i < %group.numGangMembers; %i++)
	{
		%member = %group.gangMember[%i];
		%c = getField(%member, 2);
		%rank = getField(%member, 3);

		if(isObject(%c)) //Use more reliable methods if the player is on the server
		{
			%bl_id = %c.getBLID();
			%name = %c.getPlayerName();
		}

		else
		{
			%bl_id = getField(%member, 0);
			%name = getField(%member, 1);
		}

		%rank = getGangRankName(%rank, 0);

		%var = %rank !$= "" ? " - [\c6" @ %rank @ "\c7]" : "";
		%msg = %msg NL "\c6" @ %name @ "\c7(\c6" @ %bl_id @ "\c7)" @ %var;
	}

	messageClient(%client, '', %msg);
}

function serverCmdMakeDoor(%client, %time)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(%time $= "0" || %time < 0)
	{
		serverCmdUnMakeDoor(%client);

		return;
	}

	if(!isObject(%client.gangBricks))
	{
		messageClient(%client, '', "You must be in a gang to use this command.");

		return;
	}

	if(!isObject(%player = %client.player))
	{
		return;
	}

	if(%client.getScore() < %mini.baseRaidersMakeDoorCost)
	{
		commandToClient(%client, 'centerPrint', "You need \c6$" @ %mini.baseRaidersMakeDoorCost SPC "\c0to make a door.", 2);

		return;
	}

	%start = %player.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), $BaseRaiders::InfoDist));
	%ray = containerRaycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::WaterObjectType, %player);

	%obj = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	%norm = getWords(%ray, 4, 7);

	if(!isObject(%obj) || %obj.getClassName() !$= "fxDTSBrick" || !minigameCanUse(%client, %obj) || !isObject(%data = %obj.getDataBlock()) || (%data.baseRaidersBrickType !$= "" && %data.baseRaidersBrickType != 1) || %obj.getGroup() != %client.gangBricks)
	{
		messageClient(%client, '', "You have to be looking at one of your gang's bricks to use this command.");

		return;
	}

	if(%time $= "")
	{
		messageClient(%client, '', "\c0WARNING!\c7 The disappear time for this door has been set to" SPC $BaseRaiders::DefaultDoorTime SPC "because you didn't define a timeframe.");

		%time = $BaseRaiders::DefaultDoorTime;
	}

	%time = mClampF(mRound(%time), 350, 30000);

	%obj.baseRaidersDoorTime = %time;

	commandToClient(%client, 'centerPrint', "Door time set to\c6" SPC %time SPC "\c0MS.", 2);

	if(%obj.isBaseRaidersDoor)
	{
		return;
	}

	%client.incScore(-1 * %mini.baseRaidersMakeDoorCost);

	%obj.prevBaseRaidersDoorColor = %obj.getColorID();
	%obj.isBaseRaidersDoor = true;
	%obj.baseRaidersForceColor = BaseRaiders_findClosestColor("139 125 107 255");

	%obj.setColor(%obj.baseRaidersForceColor);
}

function serverCmdUnMakeDoor(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%client.gangBricks))
	{
		messageClient(%client, '', "You must be in a gang to use this command.");

		return;
	}

	if(!isObject(%player = %client.player))
	{
		return;
	}

	%start = %player.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), $BaseRaiders::InfoDist));
	%ray = containerRaycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::WaterObjectType, %player);

	%obj = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	%norm = getWords(%ray, 4, 7);

	if(!isObject(%obj) || %obj.getClassName() !$= "fxDTSBrick" || !minigameCanUse(%client, %obj) || !isObject(%data = %obj.getDataBlock()) || (%data.baseRaidersBrickType !$= "" && %data.baseRaidersBrickType != 1) || %obj.getGroup() != %client.gangBricks)
	{
		messageClient(%client, '', "You have to be looking at one of your gang's bricks to use this command.");

		return;
	}

	if(!%obj.isBaseRaidersDoor)
	{
		commandToClient(%client, 'centerPrint', "You have to be looking at one of your gang's doors to use this command.", 2);

		return;
	}

	%obj.baseRaidersDoorTime = "";
	%obj.isBaseRaidersDoor = false;
	%obj.baseRaidersForceColor = "";

	%obj.setColor(%obj.prevBaseRaidersDoorColor);
}

function simGroup::messageGang(%obj, %x, %msg, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j)
{
	if(!%obj.isGang || !%obj.numGangMembers)
	{
		return false;
	}

	for(%i = 0; %i < %obj.numGangMembers; %i++)
	{
		%client = getField(%obj.gangMember[%i], 2);

		if(isObject(%client))
		{
			messageClient(%client, %x, %msg, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j);
		}
	}

	return true;
}

function gameConnection::getGangRank(%client)
{
	if(!isObject(%group = %client.gangBricks) || !%group.isGang)
	{
		return -1;
	}

	for(%i = 0; %i < %group.numGangMembers; %i++)
	{
		%member = %group.gangMember[%i];

		if(getField(%member, 0) == %client.getBLID())
		{
			return minClamp(getField(%member, 3), 0);
		}
	}

	return -1;
}

function getGangRankName(%rank, %hideMember)
{
	switch(%rank)
	{
		case -1:
			return "NONE";

		case 1:
			return "Colonel";

		case 2:
			return "Commander";

		case 3:
			return "Owner";

		default:
			if(%hideMember)
			{
				return "";
			}

			return "Member";
	}
}

package BaseRaiders_Gangs
{
	function slayerTeamCmdJoin(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l)
	{
		if(isObject(%client.isInBaseRaidersMini()))
		{
			serverCmdJoinGang(%client, trim(%a SPC %b SPC %c SPC %d SPC %e SPC %f SPC %g SPC %h SPC %i SPC %j SPC %k SPC %l));

			return;
		}

		parent::slayerTeamCmdJoin(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l);
	}

	function slayerTeamCmdLeave(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l)
	{
		if(isObject(%client.isInBaseRaidersMini()))
		{
			serverCmdLeaveGang(%client);

			return;
		}

		parent::slayerTeamCmdLeave(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l);
	}

	function slayerTeamCmdBalance(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l)
	{
		if(isObject(%client.isInBaseRaidersMini()))
		{
			messageClient(%client, '', "\c5You cannot use this command in this gamemode.");

			return;
		}

		parent::slayerTeamCmdBalance(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l);
	}

	function slayerTeamCmdAcceptSwap(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l)
	{
		if(isObject(%client.isInBaseRaidersMini()))
		{
			serverCmdJoinGang(%client);

			return;
		}

		parent::slayerTeamCmdAcceptSwap(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l);
	}

	function slayerTeamCmdCancelSwap(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l)
	{
		if(isObject(%client.isInBaseRaidersMini()))
		{
			serverCmdCancelInvite(%client);

			return;
		}

		parent::slayerCancelSwap(%client, %mini, %clTeam, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l);
	}

	function serverCmdTeamChat(%client, %msg)
	{
		if(!%mini = %client.isInBaseRaidersMini() || !isObject(%client.gangTeam) || !isObject(%client.gangBricks))
		{
			parent::serverCmdTeamChat(%client, %msg);

			return;
		}

		%prevPrefix = %client.clanPrefix;
		%prevSuffix = %client.clanSuffix;

		%client.clanPrefix = "\c6[" @ %client.gangBricks.name @ "]";
		%client.clanSuffix = getGangRankName(%client.getGangRank(), 1) !$= "" ? "\c6[" @ getGangRankName(%client.getGangRank(), 1) @ "]" : "";

		parent::serverCmdTeamChat(%client, %msg);

		%client.clanPrefix = %prevPrefix;
		%client.clanSuffix = %prevSuffix;
	}
};
activatePackage(BaseRaiders_Gangs);