datablock audioProfile(MoneyPickUpSound)
{
	filename = "./MoneyPickUp.wav";
	description = AudioClose3d;
	preload = true;
};

datablock itemData(BaseRaidersCashItem)
{
	category = "Weapon";
	className = "Weapon";

	uiName = "";

	shapeFile = "base/data/shapes/brickWeapon.dts";
	mass = 1;
	desnity = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	doColorShift = true;
	colorShiftColor = "0 0.6 0 1";
	image = BaseRaidersCashImage;
	canDrop = true;
	canPickup = false;
};

datablock shapeBaseImageData(BaseRaidersCashImage)
{
	shapeFile = BaseRaidersCashItem.shapeFile;
	emap = true;

	doColorShift = true;
	colorShiftColor = BaseRaidersCashItem.colorShiftColor;
	canPickup = false;
};

function serverCmdGiveMoney(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	serverCmdDonate(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13);
}

function serverCmdDonate(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(%client.getScore() < 1)
	{
		messageClient(%client, '', "You don't have any money to donate!");

		return;
	}

	%words = trim(%word0 SPC %word1 SPC %word2 SPC %word3 SPC %word4 SPC %word5 SPC %word6 SPC %word7 SPC %word8 SPC %word9 SPC %word10 SPC %word11 SPC %word12 SPC %word13);

	if(getWordCount(%words) <= 1)
	{
		messageClient(%client, '', "Usage: \c6/donate\c0 [\c6NAME\c0] [\c6AMOUNT\c0]");

		return;
	}

	%target = getWords(%words, 0, getWordCount(%words) - 2);

	%num = getWord(%words, getWordCount(%words) - 1);
	%num = mClampF(mRound(%num), 1, %client.getScore());

	if(!isObject(%target = findClientByName(%target)) || %target.minigame != %mini)
	{
		messageClient(%client, '', "No one with that name is in your minigame!");

		return;
	}

	if(%target == %client)
	{
		messageClient(%client, '', "You can't donate money to yourself!");

		return;
	}

	else if(%target.getBLID() == %client.getBLID())
	{
		messageAll('', "\c3" @ %client.getName() SPC "\c2(ID:" SPC %client.getBLID() @ ") was automatically kicked for multi-clienting.");
		%client.delete("You have been automatically kicked for multi-clienting.");

		return;
	}

	%num = maxClamp(%num, $BaseRaiders::MaxMoney - %target.getScore());

	if(%num == 0)
	{
		messageClient(%client, '', "You can't donate to\c6" SPC %target.getPlayerName() SPC "\c0because they've reached the max money.");

		return;
	}

	%client.incScore(-1 * %num);
	%target.incScore(%num);

	%donator = $BaseRaiders::HideDonator ? "Someone" : %client.getPlayerName();
	%donated = $BaseRaiders::HideDonated ? "Someone" : %target.getPlayerName();

	%mini.messageAll('', "\c7" @ %donator SPC "has donated $" @ %num SPC "to" SPC %donated @ ".");
}

function BaseRaiders::prePlayerDeath(%this, %client, %proj, %killer, %type, %area)
{
	if(!isObject(%client))
	{
		return;
	}

	%client.deadTime = $Sim::Time;

	if(!isObject(%player = %client.player))
	{
		if(%client.getScore() >= 1 && (%client.getScore() > %this.minigame.baseRaidersPoorMoney || %player.hasDamagedSomeone))
		{
			if(%client.getScore() > %this.minigame.baseRaidersMaxSafeDeathMoney + %this.minigame.baseRaidersDeathDropMoney)
			{
				%value = %client.getScore() - %this.minigame.baseRaidersMaxSafeDeathMoney;
			}

			else
			{
				%value = %client.getScore() < %this.minigame.baseRaidersDeathDropMoney ? mFloor(%client.getScore()) : %this.minigame.baseRaidersDeathDropMoney;
			}

			%client.incScore(-1 * %value);
		}

		return;
	}

	for(%i = 0; %i < %player.getDatablock().maxTools; %i++)
	{
		%item = %player.tool[%i];

		if(isObject(%item))
		{
			%vel = vectorAdd(%player.getVelocity(), getRandom(-8, 8) SPC getRandom(-8, 8) SPC getRandom(5, 10));

			%newItem = new Item()
			{
				collideable = false;
				dataBlock = %item.getName();
				position = "0 0 0";
				rotate = false;
				rotation = "1 0 0 0";
				scale = "1 1 1";
				static = false;

				canPickUp = true;

				bl_id = %client.getBLID();
				minigame = %client.minigame;
				spawnBrick = -1;
			};

			missionCleanup.add(%newItem);

			%newItem.setTransform(vectorAdd(%player.getTransform(), "0 0 2"));
			%newItem.setVelocity(%vel);

			%prev = $Game::Item::PopTime;
			$Game::Item::PopTime = %client.minigame.respawnTime_Player * 1000;
			%newItem.schedulePop();
			$Game::Item::PopTime = %prev;

			%player.tool[%i] = 0;
			messageClient(%client, 'MsgItemPickup', "", %i, 0);
		}
	}

	if(%client.getScore() < 1 || (%client.getScore() <= %this.minigame.baseRaidersPoorMoney && !%player.hasDamagedSomeone))
	{
		return;
	}

	if(%client.getScore() > %this.minigame.baseRaidersMaxSafeDeathMoney + %this.minigame.baseRaidersDeathDropMoney)
	{
		%value = $BaseRaiders::TooMuchMoneyDropPercent / 100;
		%value *= %client.getScore();
		%value += %this.minigame.baseRaidersDeathDropMoney;
		%value = mRound(%value);
	}

	else
	{
		%value = %client.getScore() < %this.minigame.baseRaidersDeathDropMoney ? mFloor(%client.getScore()) : %this.minigame.baseRaidersDeathDropMoney;
	}

	%money = new item()
	{
		collideable = false;
		datablock = BaseRaidersCashItem;
		position = "0 0 0";
		rotate = false;
		rotation = "1 0 0 0";
		scale = "1 1 1";
		static = false;

		canPickUp = false;

		minigame = %client.minigame;

		value = %value;
		displayMsg = true;
	};

	missionCleanup.add(%money);

	%money.setShapeName("$" @ %value);

	%money.setTransform(vectorAdd(%player.getTransform(), "0 0 2"));
	%money.setVelocity(vectorScale(%player.getEyeVector(), 4));
	%money.baseRaidersMoneySched = %money.schedule($BaseRaiders::MoneyCombineTime, BaseRaidersMoneyTick);

	%client.incScore(-1 * %value);
}

function item::BaseRaidersMoneyTick(%item)
{
	cancel(%item.baseRaidersMoneySched);

	%data = %item.getDataBlock();

	if(%data.getName() !$= "BaseRaidersCashItem")
	{
		return;
	}

	if(!isObject(%item.minigame))
	{
		%item.delete();

		return;
	}

	initContainerRadiusSearch(%item.getPosition(), 1, $TypeMasks::ItemObjectType);

	while(isObject(%obj = containerSearchNext()))
	{
		if(%obj != %item && %obj.getDataBlock().getName() $= "BaseRaidersCashItem" && %obj.value >= 0 && %obj.minigame == %item.minigame)
		{
			%value += %obj.value;

			if(%obj.displayMsg)
			{
				%item.displayMsg = true;
			}

			%obj.delete();
		}
	}

	%value = mRound(%value);

	if(%value >= 1)
	{
		%item.value += %value;

		%item.setShapeName("$" @ %item.value);

		cancel(%item.dieSchedule);
		%item.dieSchedule = %item.schedule($BaseRaiders::MoneyDieTime, delete);
	}

	%item.baseRaidersMoneySched = %item.schedule($BaseRaiders::MoneyCombineTime, BaseRaidersMoneyTick);
}

package BaseRaiders_Money
{
	function gameConnection::incScore(%client, %num)
	{
		if(%mini = %client.isInBaseRaidersMini())
		{
			if(%num)
			{
				if(%client.getScore() + %num > $BaseRaiders::MaxMoney)
				{
					%num = $BaseRaiders::MaxMoney - %client.getScore();
				}

				if(%client.getScore() < %mini.baseRaidersMaxSafeDeathMoney + %mini.baseRaidersDeathDropMoney && %client.getScore() + %num > %mini.baseRaidersMaxSafeDeathMoney + %mini.baseRaidersDeathDropMoney)
				{
					//messageClient(%client, '', "WARNING\c7: You've reached the maximum amount of protected money. \c0Anything ABOVE $" @ %mini.baseRaidersMaxSafeDeathMoney SPC "\c7will be dropped when you die!");
				}
			}

			else
			{
				if(%client.getScore() - %num < 0)
				{
					%num = -1 * %client.getScore();
				}
			}
		}

		parent::incScore(%client, %num);

		commandToClient(%client, 'BaseRaiders_recieveMyScore', %client.getScore());
	}

	function gameConnection::setScore(%client, %num)
	{
		if(%mini = %client.isInBaseRaidersMini())
		{
			%num = mClampF(mRound(%num), 0, $BaseRaiders::MaxMoney);

			if(%client.getScore() < %minibaseRaidersMaxSafeDeathMoney + %mini.baseRaidersDeathDropMoney && %num > %mini.baseRaidersMaxSafeDeathMoney + %mini.baseRaidersDeathDropMoney)
			{
				messageClient(%client, '', "WARNING\c7: You've reached the maximum amount of protected money. \c0Anything ABOVE $" @ %mini.baseRaidersMaxSafeDeathMoney SPC "\c7will be dropped when you die!");
			}
		}

		parent::setScore(%client, %num);

		commandToClient(%client, 'BaseRaiders_recieveMyScore', %client.getScore());
	}

	function BaseRaidersCashItem::onAdd(%data, %item)
	{
		parent::onAdd(%data, %item);

		%item.dieSchedule = %item.schedule($BaseRaiders::MoneyDieTime, delete);
	}

	function armor::onCollision(%data, %player, %col, %pos, %fade)
	{
		if(%col.getDatablock().getName() $= "BaseRaidersCashItem")
		{
			%col.canPickUp = 0;
		}

		if(isObject(%col) && %col.getDataBlock().getName() $= "BaseRaidersCashItem" && %player.getClassName() $= "Player" && isObject(%client = %player.client))
		{
			if(isObject(%client.minigame) && miniGameCanUse(%player, %col))
			{
				serverPlay3D(MoneyPickUpSound, %col.getPosition());

				if(%col.value)
				{
					%client.incScore(%col.value);

					if(%col.displayMsg)
					{
						messageClient(%client, '', "\c6You have picked up \c3$" @ %col.value SPC "\c6off the ground.");
					}
				}

				%delete = true;
			}
		}

		parent::onCollision(%data, %player, %col, %pos, %fade);

		if(%delete)
		{
			%col.delete();
		}
	}
};
activatePackage(BaseRaiders_Money);