$BaseRaiders::FilePath = "config/server/BaseRaiders";
$BaseRaiders::InfoDist = 8; //5 should be the activate distance.
$BaseRaiders::BottomPrintTime = 150;
$BaseRaiders::StartingMoney = 400;
$BaseRaiders::MoneyDieTime = 60000;
$BaseRaiders::MoneyCombineTime = 2500;
$BaseRaiders::MaxMoney = 1000000;
$BaseRaiders::TooMuchMoneyDropPercent = 5;
$BaseRaiders::HideDonator = false;
$BaseRaiders::HideDonated = false;
$BaseRaiders::DestroyPercent = 90; //Percent of money they get for destroying special bricks.
$BaseRaiders::HealAmount = 5; //Amount of HP healed per health box click.
$BaseRaiders::RegainHealPointsTime = 1875; //Amount of time it takes for electric health box to get back $BaseRaiders::HealAmount heal points.
$BaseRaiders::TempPowerMultiplier = 2; //Manual printer power gain per click.
$BaseRaiders::DefaultDoorTime = 500;
$BaseRaiders::PickupMultipleBuildTools = false; //Can you pick up multiple hammers, wrenches, or printers? //Slayer Pref?
$BaseRaiders::GeneralStrengthMultiplier = 3; //Almost certain Rein had this too. All bricks are poop week without it.
$BaseRaiders::ItemBarrelTimeMultiplier = 70;
$BaseRaiders::C4DetonateTime = 15;
$BaseRaiders::PlayerHealRate = 0.01875;
$BaseRaiders::PlayerHealRateDelay = 5000;
$BaseRaiders::CanPlantBricksOnSelf = false;
$BaseRaiders::CanPlantBricksOnGroundPlane = false;

$BaseRaiders::Gangs::MaxNameLength = 36;
$BaseRaiders::Gangs::RestrictedChars = "`~!@#$%^&*()-+=[]\\{}|;':\",./<>?"; //Not allowed to put these in your gang name. Don't modify this.
$BaseRaiders::Gangs::RestrictedWords = "sockdom,sock,C16"; //These words aren't allowed in gang names.
$BaseRaiders::Gangs::ClearBricksOnDisband = false;

$errorA = forceRequiredAddOn("GameMode_Slayer");
$errorB = forceRequiredAddOn("Brick_Large_Cubes");
$errorC = forceRequiredAddOn("Brick_WireFence");
$errorD = forceRequiredAddOn("Sound_Beeps");
$errorE = forceRequiredAddOn("Weapon_ButterflyKnife");
$errorF = forceRequiredAddOn("Weapon_DWeapons");
$errorG = forceRequiredAddOn("Weapon_Gun");
$errorH = forceRequiredAddOn("Weapon_Guns_Tetrakaikimbo");
$errorI = forceRequiredAddOn("Projectile_GravityRocket");

if($errorA == $Error::AddOn_NotFound)
{
	error("ERROR: Gamemode_BaseRaiders - required add-on GameMode_Slayer not found");
}

if($errorC == $Error::AddOn_NotFound)
{
	error("ERROR: Gamemode_BaseRaiders - required add-on Brick_WireFence not found");
}

if($errorE == $Error::AddOn_NotFound)
{
	error("ERROR: Gamemode_BaseRaiders - required add-on Weapon_ButterflyKnife not found");
}

exec("./support_DWeapons.cs");

if($errorF == $Error::AddOn_NotFound)
{
	error("ERROR: Gamemode_BaseRaiders - required add-on Weapon_DWeapons not found");
}

if($errorH == $Error::AddOn_NotFound)
{
	error("ERROR: Gamemode_BaseRaiders - required add-on Weapon_Guns_Tetrakaikimbo not found");
}

if($errorA == $Error::AddOn_NotFound || $errorC == $Error::AddOn_NotFound || $errorE == $Error::AddOn_NotFound || $errorF == $Error::AddOn_NotFound || $errorH == $Error::AddOn_NotFound)
{
	deleteVariables("$errorA");
	deleteVariables("$errorB");
	deleteVariables("$errorC");
	deleteVariables("$errorD");
	deleteVariables("$errorE");
	deleteVariables("$errorF");
	deleteVariables("$errorG");
	deleteVariables("$errorH");
	deleteVariables("$errorI");

	return;
}

deleteVariables("$errorA");
deleteVariables("$errorB");
deleteVariables("$errorC");
deleteVariables("$errorD");
deleteVariables("$errorE");
deleteVariables("$errorF");
deleteVariables("$errorG");
deleteVariables("$errorH");
deleteVariables("$errorI");

gc_FireaxeProjectile.directDamage = 30;
gc_FireaxeThrowProjectile.directDamage = 50;

exec("./support_getInfo_Dump.cs");
exec("./support_server.cs");
exec("./support_Landmine.cs");
exec("./slayerRegistry.cs");
exec("./Bricks/Bricks.cs");
exec("./Bricks/restrictedBricks.cs");
exec("./C4/C4.cs");
exec("./Sentry/sentrySupport.cs");
exec("./Sentry/sentry.cs");
exec("./gangs.cs");
exec("./money.cs");
exec("./storage.cs");
exec("./events.cs");
exec("./admin.cs");
exec("./itemPrices.cs");
exec("./help.cs");

function gameConnection::isInBaseRaidersMini(%client)
{
	if(!isObject(%mini = %client.minigame) || !isObject(%mini.gameMode) || %mini.gameMode.class !$= "BaseRaiders")
	{
		return false;
	}

	return %mini;
}

function serverCmdBaseRaiders_Handshake(%client, %version)
{
	%client.hasBaseRaidersClient = %version;
}

function gameConnection::baseRaidersPrint(%client, %player)
{
	cancel(%client.baseRaidersPrintSchedule);

	%mini = %client.minigame;

	if(!isObject(%player))
	{
		%msg = "\c6HP: \c7DEAD\c6 |";
	}

	else if(%player.isInvincible)
	{
		%msg = "\c6HP: \c4INVINCIBLE\c6 |";
	}

	else
	{
		%perc = mRound(%player.getDamagePercent() * 100);

		if(%perc <= 24)
		{
			%color = "\c2";
		}

		if(%perc >= 25 && %perc <= 49)
		{
			%color = "\c3";
		}

		if(%perc >= 50 && %perc <= 74)
		{
			%color = "<color:FF7F00>";
		}

		if(%perc >= 75)
		{
			%color = "\c0";
		}

		%msg = "\c6HP:" @ %color SPC minClamp(mRound(%player.getDataBlock().maxDamage - %player.getDamageLevel()), 1) SPC "\c6|";
	}

	%var = %mini.phase ? "\c0Fighting Phase" : "\c3Building Phase";
	%time = %mini.phaseTime;

	if(%time >= 3600)
	{
		%hour = mFloor(%time / 3600) @ ":";
		%time -= 3600 * mFloor(%time / 3600);
	}

	%minute = mFloor(%time / 60);
	%minute = %minute >= 10 || %hour $= "" ? %minute @ ":" : "0" @ %minute @ ":";
	%time -= 60 * mFloor(%time / 60);

	%second = mFloor(%time) >= 10 ? mFloor(%time) : "0" @ mFloor(%time);
	%time = %hour @ %minute @ %second;

	%msg = %msg SPC %var @ "\c6:\c3" SPC %time SPC "\c6|";
	%msg = %msg SPC "\c2$Money\c6:\c2" SPC minClamp(mRound(%client.getScore()), 0) SPC "\c6|";

	%var = minClamp(%mini.usedCityPower, 0);

	if(%mini.usedCityPower >= %mini.BaseRaidersPowerMultiplier * %mini.numMembers)
	{
		%msg = %msg SPC "\c3Used City \c3Power\c6:\c0" SPC %var @ "/" @ %mini.BaseRaidersPowerMultiplier * %mini.numMembers;
	}

	else
	{
		%msg = %msg SPC "\c3Used City \c3Power\c6: \c3" @ minClamp(%mini.usedCityPower, 0) @ "/\c3" @ %mini.BaseRaidersPowerMultiplier * %mini.numMembers @ "\c0";
	}

	if(isObject(%player))
	{
		%start = %player.getEyePoint();
		%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), $BaseRaiders::InfoDist));
		%ray = containerRaycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::WaterObjectType, %player);

		%obj = firstWord(%ray);
		%pos = getWords(%ray, 1, 3);
		%norm = getWords(%ray, 4, 7);
	}

	if(!isObject(%obj) || (%obj.getClassName() !$= "fxDTSBrick" && %obj.getClassName() !$= "Player" && %obj.getClassName() !$= "AIPlayer"))
	{
		%msg = %msg NL "\c4Info\c6: Looking at an object will show info here!";
	}

	else
	{
		%info = %obj.getBaseRaidersInfo();

		if(%info == -1)
		{
			%msg = %msg NL "\c4Info\c6: Looking at an object will show info here!";
		}

		else
		{
			%var = %info !$= "" ? %obj.getBaseRaidersInfo() : "\c6NONE";
			%msg = %msg NL "\c4Info\c6:" SPC %var;
		}
	}

	commandToClient(%client, 'bottomPrint', %msg, 0);

	%client.baseRaidersPrintSchedule = %client.schedule($BaseRaiders::BottomPrintTime, baseRaidersPrint, %client.player);
}

function miniGameSO::phaseCounter(%mini)
{
	cancel(%mini.phaseSchedule);

	if(%mini.phaseTime <= 0)
	{
		%mini.phase = !%mini.phase;
		%mini.phaseTime = %mini.phase ? %mini.BaseRaidersFightingPhaseTime : %mini.BaseRaidersBuildingPhaseTime;

		if(!%mini.phase) //Build phase
		{
			for(%i = 0; %i < %mini.numMembers; %i++)
			{
				%member = %mini.member[%i];

				if((isObject(%member.player) && %member.player.isInvincible && $Sim::Time - (%member.player.spawnTime / 1000) > 5) || (!isObject(%member.player) && $Sim::Time - %member.deadTime > %mini.respawnTime_player + 5))
				{
					if(isObject(%member.player))
					{
						messageClient(%member, '', "You \c6didn't get \c6$" @ %mini.baseRaidersGoMoney SPC "\c0for \"\c2passing go\c0\" because you're in the spawn.");
					}

					else
					{
						messageClient(%member, '', "You \c6didn't get \c6$" @ %mini.baseRaidersGoMoney SPC "\c0for \"\c2passing go\c0\" because you've been dead for too long.");
					}
				}

				else
				{
					%member.incScore(%mini.baseRaidersGoMoney);

					messageClient(%member, '', "\c2You got $" @ %mini.baseRaidersGoMoney SPC "for \"passing go\".");
				}

				if(isObject(%member.player))
				{
					if(%member.player.hasDamagedSomeone && %member.player.potentialInvincible && !%member.player.isInvincible)
					{
						%member.player.isInvincible = %member.player.potentialInvincible;
					}

					%member.player.hasDamagedSomeone = false;
				}

				%member.saveBaseRaidersStats();
			}

			if($BaseRaiders::BuildingPhaseClear !$= "")
			{
				for(%i = 0; %i < getWordCount($BaseRaiders::BuildingPhaseClear); %i++)
				{
					%group = getWord($BaseRaiders::BuildingPhaseClear, %i);

					%group.chainDeleteAllCallback = %group.getID() @ ".delete();";
					%group.chainDeleteAll();
				}

				$BaseRaiders::BuildingPhaseClear = "";
			}
		}

		else //Fight Phase
		{
			for(%i = 0; %i < %mini.numMembers; %i++)
			{
				%mini.member[%i].saveBaseRaidersStats();
			}
		}
	}

	else
	{
		%mini.phaseTime--;

		if(%mini.phaseTime == 30 || %mini.phaseTime == 15 || %mini.phaseTime == 5)
		{
			%var = %mini.phase ? "BUILDING" : "FIGHTING";
			%var2 = %mini.phaseTime == 1 ? "second" : "seconds";

			%mini.messageAll('', "Only\c6" SPC %mini.phaseTime SPC "\c0" @ %var2 SPC "until the next\c6" SPC %var SPC "\c0phase.");
		}
	}

	%mini.phaseSchedule = %mini.schedule(1000, phaseCounter);
}

function BaseRaiders::onGameModeStart(%this)
{
	%mini = %this.minigame;

	%mini.phase = 0;
	%mini.phaseTime = %mini.BaseRaidersBuildingPhaseTime;
	%mini.usedCityPower = 0;

	%mini.phaseCounter();
}

function BaseRaiders::onGameModeEnd(%this)
{
	%mini = %this.minigame;

	%mini.phase = 0;
	%mini.phaseTime = 0;
	%mini.usedCityPower = 0;

	for(%i = 0; %i < %mini.numMembers; %i++)
	{
		%this.onClientLeaveGame(%mini.member[%i]);
		cancel(%mini.member[%i].baseRaidersPrintSchedule);
	}

	cancel(%mini.phaseSchedule);

	//Delete gang brick groups. I guess.
}

function BaseRaiders::onClientJoinGame(%this, %client)
{
	if(!isObject(%player = %client.player))
	{
		return;
	}

	for(%i = 0; %i < %this.minigame.numMembers; %i++)
	{
		%member = %this.minigame.member[%i];

		if(!isObject(%member) || %member == %client)
		{
			continue;
		}

		if(%client.getBLID() == %member.getBLID())
		{
			messageAll('', "\c3" @ %client.getPlayerName() SPC "\c2(ID:" SPC %client.getBLID() @ ") was automatically kicked for multi-clienting.");
			%client.delete("You have been automatically kicked for multi-clienting. Sorry if you weren't trying to cheat.");

			return;
		}
	}

	%client.loadBaseRaidersStats();

	%client.baseRaidersPrint(%player);
}

function gameConnection::loadBaseRaidersStats(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		return;
	}

	%bl_id = $Server::LAN ? getNumKeyID() : %client.getBLID();
	%player = %client.player;

	if(isFile(%path = $BaseRaiders::FilePath @ "/" @ %bl_id @ ".txt"))
	{
		%file = new fileObject();
		%file.openForRead(%path);

		while(!%file.isEOF())
		{
			%line = %file.readLine();
			%var = strReplace(getField(%line, 0), " ", "_");
			%value = getField(%line, 1);

			switch$(%var)
			{
				case "Money":
					%client.setScore(%value);

				case "Item":
					if(!isObject(%player))
					{
						continue;
					}

					if(isNumber(firstWord(%value)) && %value >= 0 && %value <= %player.getDataBlock().maxTools && nameToID(restWords(%value)) != -1)
					{
						if(!isNumber($BaseRaiders::ItemCost_[restWords(%value)]) || $BaseRaiders::ItemCost_[restWords(%value)] < 0)
						{
							commandToClient(%client, 'centerPrint', "One or more of your saved items has been made \c6RESTRICTED\c0 since you were last saved.<br>The item(s) have been removed from your inventory.", 4);

							continue;
						}

						if(%player.tool[firstWord(%value)] == 0)
						{
							%player.weaponCount++;
						}

						%player.tool[firstWord(%value)] = nameToID(restWords(%value));
						messageClient(%client, 'MsgItemPickup', "", firstWord(%value), nameToID(restWords(%value)), 1);
					}

				case "doNotGiveDefaultEquipment":
					%client.doNotGiveDefaultEquipment = %value;

				case "defaultZoom":
					%client.defaultZoom = %value;

					if(%client.defaultZoom !$= "")
					{
						%client.noZoomCheck = true;

						messageClient(%client, '', "Automatically fixed default FOV to\c6" SPC %client.defaultZoom @  "\c0.");
					}
					
			}
		}

		%file.close();
		%file.delete();
	}

	else
	{
		%client.setScore($BaseRaiders::StartingMoney);

		if(isObject(%player))
		{
			%player.giveDefaultEquipment();
		}

		schedule(2500, %client, commandToClient, %client, 'messageBoxOk', "Welcome!", "Welcome to Base Raiders" SPC %client.getPlayerName() @ ". This looks like your first time on this server. Click <a:" @ $BaseRaiders::ForumLink @ ">HERE</a> for a guide on Base Raiders.");
	}

	%count = MainBrickGroup.getCount();

	for(%i = 0; %i < %count; %i++)
	{
		%group = MainBrickGroup.getObject(%i);

		if(!%group.isGang || !isObject(%group.gangTeam))
		{
			continue;
		}

		for(%x = 0; %x < %group.numGangMembers; %x++)
		{
			if(getField(%group.gangMember[%x], 0) $= %client.getBLID())
			{
				if(getField(%group.gangMember[%x], 3) == 3)
				{
					%group.gangTeam.addMember(%client, "Owner", 1);

					%group.client = %client;
					%group.bl_id = %client.getBLID();
				}

				else
				{
					%group.gangTeam.addMember(%client, "Member", 1);
				}

				%group.gangMember[%x] = %client.getBLID() TAB %client.getPlayerName() TAB %client TAB getField(%group.gangMember[%x], 3);

				%client.brickGroup = %group.getID();
				%client.gangBricks = %group.getID();
				%client.gangTeam = %group.gangTeam.getID();
			}
		}
	}
}

function BaseRaiders::onClientLeaveGame(%this, %client)
{
	%client.saveBaseRaidersStats();

	cancel(%client.baseRaidersPrintSchedule);
	%client.brickGroup = "BrickGroup_" @ %client.getBLID();
	%client.gangInvite = "";
	%client.gangBricks = "";
	%client.gangTeam = "";
}

function gameConnection::saveBaseRaidersStats(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		return;
	}

	%bl_id = $Server::LAN ? getNumKeyID() : %client.getBLID();
	%path = $BaseRaiders::FilePath @ "/" @ %bl_id @ ".txt";

	if(!isFile(%path))
	{
		if(%client.getScore() == $BaseRaiders::StartingMoney && %client.noZoomCheck && (%client.defaultZoom $= "" || %client.defaultZoom == 90) && !%client.doNotGiveDefaultEquipment)
		{
			if(!isObject(%player))
			{
				return;
			}

			if(isObject(%player.tool[0]) && %player.tool[0].getName() $= "hammerItem" && isObject(%player.tool[1]) && %player.tool[1].getName() $= "wrenchItem" && isObject(%player.tool[2]) && %player.tool[2].getName() $= "PrintGun")
			{
				%return = true;
			}

			for(%i = 3; %i < %player.getDataBlock().maxTools; %i++)
			{
				if(isObject(%player.tool[%i]))
				{
					%return = false;
				}
			}

			if(%return)
			{
				return;
			}
		}
	}

	else
	{
		%file = new fileObject();
		%file.openForRead(%path);

		if(%file.readLine() $= "Money	400" && %file.readLine() $= "Item	0 hammerItem" && %file.readLine() $= "Item	1 WrenchItem" && %file.readLine() $= "Item	2 PrintGun" && %file.readLine() $= "doNotGiveDefaultEquipment	0" && (%file.readLine() $= "defaultZoom	90" || %file.readLine() $= "defaultZoom	") && %file.isEOF())
		{
			%file.close();
			%file.delete();

			fileDelete(%path);

			return;
		}

		%file.close();
		%file.delete();
	}

	%file = new fileObject();
	%file.openForWrite(%path);

	%file.writeLine("Money" TAB %client.getScore());

	if(isObject(%client.player))
	{
		for(%i = 0; %i < %client.player.getDataBlock().maxTools; %i++)
		{
			%tool = %client.player.tool[%i];

			if(%tool != 0)
			{
				%file.writeLine("Item" TAB %i SPC %tool.getName());
			}
		}
	}

	%file.writeLine("doNotGiveDefaultEquipment" TAB %var = %client.doNotGiveDefaultEquipment ? 1 : 0);
	%file.writeLine("defaultZoom" TAB %var = %client.noZoomCheck ? %client.defaultZoom : "");

	%file.close();
	%file.delete();
}

function BaseRaiders::minigameCanDamage(%this, %objA, %objB)
{
	if(!%this.minigame.phase || (%objA.getClassName() $= "Player" && %objA.isInvincible) || (%objB.getClassName() $= "Player" && %objB.isInvincible))
	{
		return false;
	}

	return -1; //Let Slayer decide.
}

function BaseRaiders::minigameClientCanDamage(%this, %clientA, %clientB)
{
	if(!%this.minigame.phase || (isObject(%clientA.player) && %clientA.isInvincible) || (isObject(%clientB.player) && %clientB.player.isInvincible))
	{
		return false;
	}

	return -1; //Let Slayer decide.
}

function itemData::getBaseRaidersCost(%data, %client, %excludeBulk)
{
	if(isObject(%client) && !%mini = %client.isInBaseRaidersMini())
	{
		return 0;
	}

	if(isObject(%client) && %mini.baseRaidersCost[strReplace(%data.uiName, " ", "")] !$= "")
	{
		%cost = %mini.baseRaidersCost[strReplace(%data.uiName, " ", "")];
	}

	else if($BaseRaiders::ItemCost_[%data.getName()] !$= "")
	{
		%cost = $BaseRaiders::ItemCost_[%data.getName()];
	}

	else
	{
		%cost = %data.baseRaidersCost;
	}

	%cost = %cost $= "" || %data.baseRaidersCost < 0 ? -1 : %cost;

	if(!%excludeBulk && %cost > 0 && isObject(%client) && isObject(%brick = %client.wrenchBrick) && isObject(%brickData = %brick.getDataBlock()) && %brickData.baseRaidersBrickType == 5 && %brickData.baseRaidersStorageSpace >= 2)
	{
		%bulkCost = %cost * %brickData.baseRaidersStorageSpace;

		%discount = 0.2;

		if(isObject(%mini))
		{
			%discount = %mini.baseRaidersItemBarrelDiscount / 100;
		}

		%discount *= %bulkCost;

		%cost = mRound(%bulkCost - %discount);
	}

	return %cost;
}

function serverCmdBaseRaiders_getItemPrice(%client, %ui)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		return;
	}

	if(trim(%ui) $= "" || %ui $= "NONE")
	{
		return;
	}

	%count = getDataBlockGroupSize();

	for(%i = 0; %i < %count; %i++)
	{
		%d = getDataBlock(%i);

		if(%d.getClassName() $= "ItemData" && %d.uiName $= %ui)
		{
			%data = %d;

			break;
		}
	}

	if(isObject(%brick = %client.wrenchBrick) && !%brick.isBuyBrick && isObject(%brick.item) && %brick.item.getDataBlock() == %data)
	{
		return;
	}

	%cost = %data.getBaseRaidersCost(%client);

	%cannotAfford = %client.getScore() < %cost || %cost == -1;

	commandToClient(%client, 'BaseRaiders_recieveItemPrice', %cost, %cannotAfford);
}

function serverCmdDontSpawnWithTools(%client)
{
	%client.doNotGiveDefaultEquipment = !%client.doNotGiveDefaultEquipment;

	%var = %client.doNotGiveDefaultEquipment ? "NO LONGER" : "NOW";
	messageClient(%client, '', "You will\c6" SPC %var SPC "\c0spawn with default tools.");
}

function serverCmdBuy(%client)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%client.player))
	{
		return;
	}

	%buyBrick = new fxDTSBrick()
	{
		angleID = 1;
		client = %client;
		colorFxID = 0;
		colorID = 0;
		dataBlock = brick1x1Data;
		isBasePlate = 1;
		isPlanted = 1;
		position = getRandom(-10000, 10000) SPC getRandom(-10000, 10000) SPC getRandom(-50, -10000);
		printID = 0;
		rotation = "1 0 0 0";
		scale = "1 1 1";
		shapeFxID = 0;
		stackBL_ID = -1;

		brickGroup = %client.brickGroup;
		isBuyBrick = 1;
	};

	%buyBrick.schedule(300000, delete); //Delete if they don't buy something in 5 minutes.

	if(isObject(%client.lastBuyBrickItem))
	{
		%buyBrick.setItem(%client.lastBuyBrickItem);
	}

	%client.wrenchBrick = %buyBrick;
	%buyBrick.sendWrenchData(%client);

	if(%client.hasBaseRaidersClient)
	{
		commandToClient(%client, 'baseRaiders_openBuyItemGui');
	}

	else
	{
		commandToClient(%client, 'openWrenchDlg', "SELECT AN ITEM TO PURCHASE", 0, 0, 1);
	}
}

package BaseRaiders
{
	function gameConnection::autoAdminCheck(%client)
	{
		commandToClient(%client, 'baseRaiders_handshake');

		return parent::autoAdminCheck(%client);
	}

	function serverCmdSlayer_getTeamPrefs_Start(%client, %team, %template, %count)
	{
		if(isObject(%template.getGroup()) && %template.getGroup().className $= "BaseRaiders")
		{
			%team = 1;
			%count = 0;
		}

		parent::serverCmdSlayer_getTeamPrefs_Start(%client, %team, %template, %count);
	}

	function serverCmdClearBricks(%client)
	{
		if(%client.isInBaseRaidersMini())
		{
			messageClient(%client, '', "This command is disabled while in a \c6Base Raiders\c0 minigame.");

			return;
		}

		parent::serverCmdClearBricks(%client);
	}

	function serverCmdSetWrenchData(%client, %wrenchData)
	{
		%itemData = restWords(getField(%wrenchData, 4));

		if(!isObject(%mini = %client.isInBaseRaidersMini()) || !isObject(%brick = %client.wrenchBrick) || !isObject(%player = %client.player))
		{
			parent::serverCmdSetWrenchData(%client, %wrenchData);

			return;
		}

		%brickData = %brick.getDataBlock();
		%prevItem = isObject(%brick.item) ? %brick.item.getDataBlock() : 0;

		if(!isObject(%itemData) || %itemData.getClassName() !$= "ItemData")
		{
			parent::serverCmdSetWrenchData(%client, %wrenchData);

			if(%brick.isBuyBrick)
			{
				%brick.onDeath();
				%brick.delete();

				return;
			}

			if(!%client.isAdmin)
			{
				%brick.setNTObjectName("");
			}

			if(%mini.baseRaidersRestrictLights && !%client.isAdmin)
			{
				%brick.setLight(0);
			}

			%brick.setEmitter(0);
			%brick.setRaycasting(1);

			if(%brickData.baseRaidersBrickType >= 2)
			{
				%brick.setColliding(1);
				%brick.setRendering(1);
			}

			return;
		}

		%cost = %itemData.getBaseRaidersCost(%client);

		if(%cost == -1)
		{
			messageClient(%client, '', "Restricted item.");

			parent::serverCmdSetWrenchData(%client, %wrenchData);

			if(%brick.isBuyBrick)
			{
				%brick.onDeath();
				%brick.delete();

				return;
			}

			%brick.setItem(isObject(%prevItem) ? %prevItem : 0);

			if(!%client.isAdmin)
			{
				%brick.setNTObjectName("");
			}

			if(%mini.baseRaidersRestrictLights && !%client.isAdmin)
			{
				%brick.setLight(0);
			}

			%brick.setEmitter(0);
			%brick.setRaycasting(1);

			if(%brickData.baseRaidersBrickType >= 2)
			{
				%brick.setColliding(1);
				%brick.setRendering(1);
			}

			return;
		}

		if(%brick.isBuyBrick)
		{
			if(%client.getScore() < %cost)
			{
				messageClient(%client, '', "You need at least \c6$" @ %cost SPC "\c0to buy this item.");

				parent::serverCmdSetWrenchData(%client, %wrenchData);

				if(%brick.isBuyBrick)
				{
					%brick.onDeath();
					%brick.delete();

					return;
				}

				%brick.setItem(0);

				if(!%client.isAdmin)
				{
					%brick.setNTObjectName("");
				}

				if(%mini.baseRaidersRestrictLights && !%client.isAdmin)
				{
					%brick.setLight(0);
				}

				%brick.setEmitter(0);
				%brick.setRaycasting(1);

				if(%brickData.baseRaidersBrickType >= 2)
				{
					%brick.setColliding(1);
					%brick.setRendering(1);
				}

				return;
			}
		}

		else
		{
			if(%client.getScore() < %cost && (!isObject(%brick.item) || %itemData != %brick.item.getDataBlock()))
			{
				messageClient(%client, '', "You need at least \c6$" @ %cost SPC "\c0to buy this item.");

				parent::serverCmdSetWrenchData(%client, %wrenchData);

				if(%brick.isBuyBrick)
				{
					%brick.onDeath();
					%brick.delete();

					return;
				}

				%brick.setItem(isObject(%prevItem) ? %prevItem : 0);

				if(!%client.isAdmin)
				{
					%brick.setNTObjectName("");
				}

				if(%mini.baseRaidersRestrictLights && !%client.isAdmin)
				{
					%brick.setLight(0);
				}

				%brick.setEmitter(0);
				%brick.setRaycasting(1);

				if(%brickData.baseRaidersBrickType >= 2)
				{
					%brick.setColliding(1);
					%brick.setRendering(1);
				}

				return;
			}
		}

		for(%i = 0; %i < %player.getDataBlock().maxTools; %i++)
		{
			if(!isObject(%player.tool[%i]))
			{
				%freeSlot = %i;
				break;
			}
		}

		if(%freeSlot $= "" && %brick.isBuyBrick)
		{
			messageClient(%client, '', "Inventory FULL.");

			parent::serverCmdSetWrenchData(%client, %wrenchData);

			if(%brick.isBuyBrick)
			{
				%brick.onDeath();
				%brick.delete();

				return;
			}

			%brick.setItem(isObject(%prevItem) ? %prevItem : 0);

			if(!%client.isAdmin)
			{
				%brick.setNTObjectName("");
			}

			if(%mini.baseRaidersRestrictLights && !%client.isAdmin)
			{
				%brick.setLight(0);
			}

			%brick.setEmitter(0);
			%brick.setRaycasting(1);

			if(%brickData.baseRaidersBrickType >= 2)
			{
				%brick.setColliding(1);
				%brick.setRendering(1);
			}

			return;
		}

		if(!%brick.isBuyBrick && isObject(%brick.item) && %itemData == %brick.item.getDataBlock())
		{
			parent::serverCmdSetWrenchData(%client, %wrenchData);

			%brick.setItem(isObject(%prevItem) ? %prevItem : 0);

			if(!%client.isAdmin)
			{
				%brick.setNTObjectName("");
			}

			if(%mini.baseRaidersRestrictLights && !%client.isAdmin)
			{
				%brick.setLight(0);
			}

			%brick.setEmitter(0);
			%brick.setRaycasting(1);

			if(%brickData.baseRaidersBrickType >= 2)
			{
				%brick.setColliding(1);
				%brick.setRendering(1);
			}

			return;
		}

		%client.incScore(-1 * %cost);

		parent::serverCmdSetWrenchData(%client, %wrenchData);

		if(%brickData.baseRaidersBrickType == 5)
		{
			%brick.setItem(0);

			%var = getSubStr(%itemData.uiName, strLen(%itemData.uiName) - 1, 1) $= "s" ? %itemData.uiName @ "'" : %itemData.uiName @ "s";
			messageClient(%client, '', "You bought\c6" SPC %brickData.baseRaidersStorageSpace SPC %var SPC "\c0for \c6$" @ %cost SPC "\c0and got a discount of\c6" SPC %mini.baseRaidersItemBarrelDiscount @ "%\c0 for buying in bulk\c0.");

			%brick.numItemBarrelItems = 0;
			%brick.numItemBarrelItemsTaken = 0;
			%brick.itemBarrelItem = %itemData;
			%brick.itemBarrelTick = %brick.schedule(%itemData.getBaseRaidersCost(%client, 1) * $BaseRaiders::ItemBarrelTimeMultiplier, baseRaidersItemBarrelTick);

			%brick.baseRaidersForcePrint = getSubStr(%itemData.uiName, 0, 1);
		}

		else
		{
			messageClient(%client, '', "You bought a\c6" SPC %itemData.uiName SPC "\c0for \c6$" @ %cost @ "\c0.");
		}

		if(%brick.isBuyBrick)
		{
			%client.lastBuyBrickItem = %itemData.getName();

			messageClient(%client, 'MsgItemPickup', '', %freeSlot, %itemData, 0);
			%player.tool[%freeSlot] = %itemData;
			%player.weaponCount++;
		}
	}

	function armor::onCollision(%data, %player, %col, %pos, %normal, %a, %b)
	{
		if(!isObject(%client = %player.client) || !isObject(%mini = %client.isInBaseRaidersMini()) || !isObject(%col) || %col.getClassName() !$= "Item" || !%col.canPickUp)
		{
			parent::onCollision(%data, %player, %col, %pos, %normal, %a, %b);

			return;
		}

		if(%client.doNotGiveDefaultEquipment && (%col.getDataBlock().getName() $= "hammerItem" || %col.getDataBlock().getName() $= "WrenchItem" || %col.getDataBlock().getName() $= "printGun"))
		{
			return;
		}

		parent::onCollision(%data, %player, %col, %pos, %normal, %a, %b);

		if(isObject(%col.spawnBrick))
		{
			%col.spawnBrick.setItem(0);
		}

		return; //Temporary band-aid. Not allowing picking up duplicate items because it's buggy.

		%freeSlot = -1;
		%duplicate = false;

		for(%i = 0; %i < %data.maxTools; %i++)
		{
			%tool = %player.tool[%i];

			if(%freeSlot == -1 && !isObject(%tool))
			{
				%freeSlot = %i;
			}

			else if(isObject(%col) && %tool == %col.getDataBlock())
			{
				if(!$BaseRaiders::PickupMultipleBuildTools && (%col.getDataBlock().getName() $= "hammerItem" || %col.getDataBlock().getName() $= "WrenchItem" || %col.getDataBlock().getName() $= "printGun"))
				{
					continue;
				}

				%duplicate = true;
			}
		}

		if(%freeSlot != -1 && %duplicate)
		{
			messageClient(%client, 'MsgItemPickup', '', %freeSlot, %col.getDataBlock(), 0);
			%player.tool[%freeSlot] = %col.getDataBlock();
			%player.weaponCount++;

			%col.delete();

			//%col.pickup(%player, 1);
			//%col.getDataBlock().onPickup(%col, %player, "");
			//%col.canPickUp = false;

			//if(isObject(%col))
			//{
				//if(isObject(%col.spawnBrick))
				//{
					//%col.respawn();
					//%col.canPickUp = false;
				//}

				//else
				//{
					//%col.delete();
				//}
			//}
		}
	}

	function projectileData::onCollision(%data, %proj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%data, %proj, %col, %fade, %pos, %normal);

		if(!isObject(%col) || %col.getClassName() !$= "fxDTSBrick")
		{
			return;
		}

		if(!minigameCanUse(%proj, %col))
		{
			return;
		}

		if(!isObject(%client = %proj.client))
		{
			%client = %proj.sourceObject.client;
		}

		if(!isObject(%client))
		{
			return;
		}

		%brickData = %col.getDataBlock();

		if(%proj.getDataBlock().getName() $= "gc_DBulletImpactProjectile")
		{
			return;
		}

		%damage = minClamp(%proj.getDataBlock().directDamage / minClamp(%brickData.baseRaidersStrengthMultiplier * $BaseRaiders::GeneralStrengthMultiplier, 1), 0);

		%col.baseRaiders_damage(%damage, %client);
	}

	function gc_raycastDamageSystem(%image, %player, %col, %pos)
	{
		%parent = parent::gc_raycastDamageSystem(%image, %player, %col, %pos);

		if(%col.getClassName() !$= "fxDTSBrick")
		{
			return %parent;
		}

		if(!minigameCanUse(%player, %col))
		{
			return %parent;
		}

		if(!isObject(%client = %player.client))
		{
			return %parent;
		}

		%brickData = %col.getDataBlock();

		%damage = minClamp(%image.directDamage / minClamp(%brickData.baseRaidersStrengthMultiplier * $BaseRaiders::GeneralStrengthMultiplier, 1), 0);

		%col.baseRaiders_damage(%damage, %client);

		return %parent;
	}

	function printGunImage::onHitObject(%data, %player, %slot, %col, %pos, %normal)
	{
		parent::onHitObject(%data, %player, %slot, %col, %pos, %normal);

		if(%col.getClassName() !$= "fxDTSBrick")
		{
			return;
		}

		%brickData = %col.getDataBlock();

		if(%brickData.hasPrint)
		{
			return;
		}

		if(!isObject(%client = %player.client))
		{
			return;
		}

		if(!%mini = %client.isInBaseRaidersMini())
		{
			return;
		}

		if(!miniGameCanUse(%player, %col))
		{
			return;
		}

		if(%col.getGroup().bl_id != %client.getBLID() && %col.getGroup() != %client.gangBricks)
		{
			return;
		}

		%num = %mini.phase ? 6 : 20;
		%col.health = %col.getBaseRaidersHealth() + (%num / minClamp(%brickData.baseRaidersstrengthMultiplier, 1));
		%col.health = mClampF(%col.getBaseRaidersHealth(), 0, 100);
	}

	function gameConnection::createPlayer(%client, %pos)
	{
		%parent = parent::createPlayer(%client, %pos);

		if(isObject(%player = %client.player) && %client.isInBaseRaidersMini())
		{
			%player.setDataBlock(playerNoJet);

			if(%client.doNotGiveDefaultEquipment)
			{
				%player.clearTools();
			}
		}

		return %parent;
	}

	function player::damage(%player, %source, %pos, %damage, %type)
	{
		if(!isObject(%client = %player.client))
		{
			parent::damage(%player, %source, %pos, %damage, %type);
			return;
		}

		if(!%mini = %client.isInBaseRaidersMini())
		{
			parent::damage(%player, %source, %pos, %damage, %type);
			return;
		}

		if(!isObject(%source))
		{
			parent::damage(%player, %source, %pos, %damage, %type);
			return;
		}

		switch$(%source.getClassName())
		{
			case "player" or "AIPlayer":
				%attacker = %source;

			case "gameConnection" or "AIConnection":
				%attacker = %source.player;

			case "projectile":
				%attacker = %source.sourceObject;

			case "vehicle":
				%attacker = %source.getMountedObject(0);
		}

		if(%attacker.client.minigame != %mini)
		{
			parent::damage(%player, %source, %pos, %damage, %type);
			return;
		}

		if(%attacker.isInvincible || %player.isInvincible)
		{
			%damage = 0;
		}

		else
		{
			%attacker.hasDamagedSomeone = true;
			%attacker.isInvincible = 0;
		}

		%player.setRepairRate(0);

		cancel(%player.repairRateDelay);
		%player.repairRateDelay = %player.schedule($BaseRaiders::PlayerHealRateDelay, setRepairRate, $BaseRaiders::PlayerHealRate);

		parent::damage(%player, %source, %pos, %damage, %type);
	}

	function weaponImage::onFire(%data, %obj, %slot)
	{
		if(!isObject(%client = %obj.client))
		{
			return parent::onFire(%data, %obj, %slot);
		}

		if(!%mini = %client.isInBaseRaidersMini())
		{
			return parent::onFire(%data, %obj, %slot);
		}

		%name = %data.getName();

		if(!%client.isAdmin && (%name $= "pearlSprayCanImage" || %name $= "chromeSprayCanImage" || %name $= "glowSprayCanImage" || %name $= "blinkSprayCanImage" || %name $= "swirlSprayCanImage" || %name $= "rainbowSprayCanImage" || %name $= "jelloSprayCanImage"))
		{
			commandToClient(%client, 'centerPrint', "You must be an \c6Admin\c0 to use this paint FX.", 2);

			return %obj;
		}

		return parent::onFire(%data, %obj, %slot);
	}

	function hammerImage::onFire(%data, %obj, %slot)
	{
		if($Sim::Time - %obj.lastHammerFireTime < 0.2)
		{
			%obj.playThread(2, armAttack);

			return;
		}

		%obj.lastHammerFireTime = $Sim::Time;

		parent::onFire(%data, %obj, %slot);
	}

	function printGunImage::onFire(%data, %obj, %slot)
	{
		if($Sim::Time - %obj.lastPrintGunFireTime < 0.25)
		{
			return;
		}

		%obj.lastPrintGunFireTime = $Sim::Time;

		parent::onFire(%data, %obj, %slot);
	}

	function armor::onTrigger(%data, %obj, %slot, %val)
	{
		parent::onTrigger(%data, %obj, %slot, %val);

		if(%slot == 3)
		{
			%obj.isCrouching = %val;
		}
	}

	function Slayer_TeamSO::removeMember(%this, %client, %respawn)
	{
		%mini = %this.minigame;

		if(isObject(%player = %client.player))
		{
			%data = %player.getDataBlock();

			for(%i = 0; %i < %data.maxTools; %i++)
			{
				%tool[%i] = %player.tool[%i];
			}
		}

		%parent = parent::removeMember(%this, %client, %respawn);

		if(%client.isInBaseRaidersMini() && !%respawn && isObject(%player))
		{
			%player.weaponCount = 0;

			for(%i = 0; %i < %data.maxTools; %i++)
			{
				messageClient(%client, 'MsgItemPickup', "", %i, %tool[%i], 0);
				%player.tool[%i] = %tool[%i];

				if(isObject(%tool[%i]) && %tool[%i].className $= "Weapon")
				{
					%player.weaponCount++;
				}
			}
		}

		return %parent;
	}
};
activatePackage(BaseRaiders);