function serverCmdPut(%client, %num)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%player = %client.player))
	{
		return;
	}

	if(%num !$= "")
	{
		serverCmdDeposit(%client, %num);

		return;
	}

	%start = %player.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), $BaseRaiders::InfoDist));
	%ray = containerRaycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::WaterObjectType, %player);

	%obj = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	%norm = getWords(%ray, 4, 7);

	if(!isObject(%obj) || %obj.getClassName() !$= "fxDTSBrick" || !minigameCanUse(%client, %obj) || !isObject(%data = %obj.getDataBlock()) || %data.baseRaidersBrickType != 4)
	{
		messageClient(%client, '', "You have to be looking at a storage brick to use this command.");

		return;
	}

	if(!isObject(%player.tool[%player.currTool]))
	{
		return;
	}

	if(getWordCount(%obj.storedItems) >= %data.baseRaidersStorageSpace)
	{
		messageClient(%client, '', "This storage brick is FULL.");

		return;
	}

	%obj.storedItems = addItemToList(%obj.storedItems, %player.tool[%player.currTool].getName());

	messageClient(%client, 'MsgItemPickup', "", %player.currTool, 0, 0);
	%player.tool[%player.currTool] = 0;
	%player.weaponCount--;
	serverCmdUnUseTool(%client);
}

function serverCmdTake(%client, %num)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%player = %client.player))
	{
		return;
	}

	%start = %player.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), $BaseRaiders::InfoDist));
	%ray = containerRaycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::WaterObjectType, %player);

	%obj = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	%norm = getWords(%ray, 4, 7);

	if(!isObject(%obj) || !isObject(%data = %obj.getDataBlock()) || (%data.baseRaidersBrickType != 4 && %data.baseRaidersBrickType != 6))
	{
		messageClient(%client, '', "You have to be looking at a storage brick to use this command.");
	}

	if(%data.baseRaidersBrickType == 6)
	{
		serverCmdWithdraw(%client, %num);

		return;
	}

	if(%num < 0 || %num > getWordCount(%obj.storedItems))
	{
		for(%i = 0; %i < getWordCount(%obj.storedItems); %i++)
		{
			messageClient(%client, '', "\c3" @ %i @ ".\c6" SPC getWord(%obj.storedItems, %i).uiName);
		}

		return;
	}

	%item = nameToID(getWord(%obj.storedItems, %num));

	for(%i = 0; %i < %player.getDataBlock().maxTools; %i++)
	{
		if(!isObject(%player.tool[%i]))
		{
			%freeSlot = %i;
			break;
		}
	}

	if(%freeSlot $= "")
	{
		messageClient(%client, '', "Inventory FULL.");

		return;
	}

	%obj.storedItems = removeItemFromList(%obj.storedItems, getWord(%obj.storedItems, %num));

	if(!isObject(%item))
	{
		return;
	}

	messageClient(%client, 'MsgItemPickup', "", %freeSlot, %item, 0);
	%player.tool[%freeSlot] = %item;
	%player.weaponCount++;
}

function serverCmdDeposit(%client, %num)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%player = %client.player))
	{
		return;
	}

	%start = %player.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), $BaseRaiders::InfoDist));
	%ray = containerRaycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::WaterObjectType, %player);

	%obj = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	%norm = getWords(%ray, 4, 7);

	if(!isObject(%obj) || !isObject(%data = %obj.getDataBlock()) || %data.baseRaidersBrickType != 6)
	{
		messageClient(%client, '', "You have to be looking at a safe brick to use this command.");

		return;
	}

	if(%mini.baseRaidersGangSafeGangUseOnly && (%client.gangBricks != %obj.getGroup() || %client.getBLID() != %obj.getGroup().bl_id))
	{
		if(%obj.getGroup().isGang)
		{
			messageClient(%client, '', "You have to be in the\c6" SPC %obj.getGroup().name SPC "\c0gang to deposit money in this safe.");
		}

		else
		{
			messageClient(%client, '', "Only\c6" SPC %obj.getGroup().name SPC "\c0can deposit money in this safe.");
		}

		return;
	}

	if(!%mini.baseRaidersSafeUseDuringFightPhase && %mini.phase)
	{
		messageClient(%client, '', "You can only use safes during the \c6BUILDING\c0 phase.");

		return;
	}

	if(%client.getScore() < 1)
	{
		messageClient(%client, '', "You have no money to deposit!");

		return;
	}

	%num = mClampF(%num, 1, %client.getScore());

	%client.incScore(-1 * %num);
	%obj.moneyStored += %num;
}

function serverCmdWithdraw(%client, %num)
{
	if(!%mini = %client.isInBaseRaidersMini())
	{
		messageClient(%client, '', "You must be in a \c6Base Raiders\c0 minigame to use this command.");

		return;
	}

	if(!isObject(%player = %client.player))
	{
		return;
	}

	%start = %player.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), $BaseRaiders::InfoDist));
	%ray = containerRaycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::WaterObjectType, %player);

	%obj = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	%norm = getWords(%ray, 4, 7);

	if(!isObject(%obj) || !isObject(%data = %obj.getDataBlock()) || %data.baseRaidersBrickType != 6)
	{
		messageClient(%client, '', "You have to be looking at a safe brick to use this command.");

		return;
	}

	if(%mini.baseRaidersGangSafeGangUseOnly && (%client.gangBricks != %obj.getGroup() || %client.getBLID() != %obj.getGroup().bl_id))
	{
		if(%obj.getGroup().isGang)
		{
			messageClient(%client, '', "You have to be in the\c6" SPC %obj.getGroup().name SPC "\c0gang to withdraw money from this safe.");
		}

		else
		{
			messageClient(%client, '', "Only\c6" SPC %obj.getGroup().name SPC "\c0can deposit money in this safe.");
		}

		return;
	}

	if(!%mini.baseRaidersSafeUseDuringFightPhase && %mini.phase)
	{
		messageClient(%client, '', "You can only use safes during the \c6BUILDING\c0 phase.");

		return;
	}

	if(%obj.moneyStored < 1)
	{
		messageClient(%client, '', "There's no money in this safe to withdraw!");

		return;
	}

	%num = mClampF(%num, 1, %obj.moneyStored);

	%client.incScore(%num);
	%obj.moneyStored -= %num;
}