//This file fixes some of the issues in Weapon_DWeapons and removes the grenade launcher from the bullpup while in a Base Raiders minigame.
//It also removes /fixFov because it's not necessary.

package DWeapons_Fix
{
	//This function was badly made. Was super easy to fire through walls.
	function gc_weaponFireRaycast(%image, %obj)
	{
		//%muzzlePoint = %obj.getMuzzlePoint(0); //- Gross. Allows you to shoot through walls if you stand close enough to them.
		//%muzzleVec = %obj.getMuzzleVector(0); //- Gross. Allows you to shoot through walls if you stand close enough to them.
		%muzzlePoint = %obj.getEyePoint();
		%muzzleVec = %obj.getEyeVector();
		%shellCount = %image.projectileCount;
		%range = %image.range;
		%tracer = %image.tracer;

		if(%image.item.image @ "Scoped" $= %image.getName())
		{
			%spread = %image.spreadAim;
		}

		else
		{
			%spread = %image.spread;
		}

		if(%image.ignoreSpread != 1)
		{
			if(%obj.isCrouched() == 1)
			{
				%spread -= 0.0002;
			}

			if(%image.fullSway)
			{
				if(!isObject(%obj.getObjectMount()) && vectorLen(%obj.getVelocity()) >= 1)
				{
					%spread += 0.001;
				}
			}

			else
			{
				if(vectorLen(%obj.getVelocity()) >= 5 && !isObject(%obj.getObjectMount()))
				{
					%spread += 0.001;
				}
			}

			if(%obj.lastShotTime > getSimTime())
			{
				if(%spread < 0.003)
				{
					%spread += (0.0001 * %obj.lastShotTimeMultiplier);
				}

				%obj.lastShotTimeMultiplier++;
			}

			else
			{
				%obj.lastShotTimeMultiplier = 1;
			}

			%obj.lastShotTime = getSimTime() + 400;
		}

		%obj.spawnExplosion(gc_weaponRecoil, "1 1 1");

		for(%shell = 0; %shell < %shellCount; %shell++)
		{
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;

			if(%spread > 0)
			{
				%velocity = vectorNormalize(matrixMulVector(matrixCreateFromEuler(%x SPC %y SPC %z), vectorScale(%muzzleVec, 100)));
			}

			else
			{
				%velocity = vectorNormalize(%muzzleVec);
			}

			if(%range <= 500)
			{
				%raycast = containerRayCast(%muzzlePoint, vectorAdd(%muzzlePoint, vectorScale(%velocity, %range)),$TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType, %obj);

				%col = firstWord(%raycast);

				if(isObject(%col))
				{
					%rayPos = posFromRaycast(%raycast);
				}

				else
				{
					%rayPos = vectorAdd(%muzzlePoint, vectorScale(%velocity, %range));
				}
			}

			else
			{
				%raycast = containerRayCast(%muzzlePoint, vectorAdd(%muzzlePoint, vectorScale(%velocity, %range / 2)),$TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType, %obj);

				if(!isObject(firstWord(%raycast)))
				{
					%midPos = posFromRaycast(%raycast);
					%raycast = containerRayCast(%midPos, vectorAdd(%midPos, vectorScale(%velocity, %range / 2)),$TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType, %obj);
				}

				%col = firstWord(%raycast);

				if(%col == 0)
				{
					%rayPos = vectorAdd(%muzzlePoint, vectorScale(%velocity, %range));
				}

				else
				{
					%rayPos = posFromRaycast(%raycast);
				}
			}

			if(isObject(%col))
			{
				gc_RaycastDamageSystem(%image, %obj, %col, %rayPos);

				%p = new Projectile()
				{
					dataBlock = gc_DBulletImpactProjectile;
					initialPosition = %rayPos;
					initialVelocity = %velocity;
					sourceObject = %obj;
					sourceSlot = 0;
					client = %obj.client;
				};

				missionCleanup.add(%p);
			}

			if(%tracer > 0)
			{
				%p = new StaticShape()
				{
					dataBlock = gc_BulletTrailStatic;
				};

				missionCleanup.add(%p);

				%x = firstWord(%velocity) / 2;
				%y = (getWord(%velocity, 1) + 1) / 2;
				%z = getWord(%velocity, 2) / 2;

				%p.setTransform(%muzzlePoint SPC vectorNormalize(%x SPC %y SPC %z) SPC mDegToRad(180));
				%p.setScale(%tracer SPC vectorDist(%muzzlePoint, %rayPos) SPC %tracer);
			}
		}
	}

	function messageAll(%tagged, %msg, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n)
	{
		if(getTaggedString(%tagged) $= "" && %msg $= "AddDamageType() - gc_bleed file \"Add-ons/Weapon_GCatsSpecialWeapons/CI_bleeding.png\" does not exist!")
		{
			if($DamageType::gc_bleed $= "")
			{
				addDamageType("gc_bleed", '<bitmap:Add-Ons/Weapon_DWeapons/CI_bleeding> %1', '%2 <bitmap:Add-Ons/Weapon_DWeapons/CI_bleeding> %1', 0.2, 1);
			}

			return;
		}

		parent::messageAll(%tagged, %msg, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n);
	}

	function gc_BullpupGLImage::onMount(%data, %obj, %slot)
	{
		parent::onMount(%data, %obj, %slot);

		if(isObject(%client = %obj.client) && !%mini = %client.isInBaseRaidersMini())
		{
			return;
		}

		%obj.unMountImage(%slot);
		%obj.mountImage(gc_BullpupImage, %slot);

		commandToClient(%client, 'centerPrint', "This feature is disabled in \c6Base Raiders\c0 minigames.", 2);
	}
};
activatePackage(DWeapons_Fix);

deactivatePackage(gc_ScopesPackage);
package gc_ScopesPackage
{
	function GameConnection::onClientLeaveGame(%client)
	{
		if(isObject(%client.player.gc_laserEffect))
		{
			%client.player.gc_laserEffect.delete();
		}

		parent::onClientLeaveGame(%client);
	}

	function serverCmdFixFov(%client, %fov)
	{
		//Useless if statement was here that checked if the client exists, the client will always exist in this function though.

		%client.defaultZoom = mClampF(%fov, 75, 120);
		%client.noZoomCheck = true;

		messageClient(%client, '', "Fixed default FOV to" SPC %client.defaultZoom @ ".");
	}

	function GameConnection::spawnPlayer(%client)
	{
		parent::spawnPlayer(%client);

		if(!%client.noZoomCheck)
		{
			%client.defaultZoom = %client.getControlCameraFov();
			messageClient(%client, '', "\c3Type \c0/fixfov [your fov]\c3 to set the field of view to which weapons reset.");
		}
	}

	function GameConnection::onDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		%var = %client.defaultZoom !$= "" ? %client.defaultZoom : 90;
		%client.setControlCameraFov(%var);
		//Fixed an issue here that caused a console error and this function never actually got called before.

		parent::onDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc);
	}

	function armor::onTrigger(%this, %player, %slot, %val)
	{
		if(isObject(%player))
		{
			if(%player.getMountedImage(0).gc_MeleeSecondary == 1 && %slot $= 4 && %val)
			{
				if(%player.getImageState(0) $= "Ready")
				{
					%player.setImageAmmo(0, 0);
				}
			}
		}

		if(isObject(%image = %player.getMountedImage(0)))
		{
			if(isObject(%vehicle = %player.getObjectMount()))
			{
				for(%i = 0; %i < 8; %i++)
				{
					if(%vehicle.getMountedObject(%i) == %player)
					{
						%vehicleSlot = %i;
						break;
					}
				}
			}

			if(%image.item.gc_zoom $= "")
			{
				parent::onTrigger(%this, %player, %slot, %val);
				return;
			}

			if((%image.item.image $= %image.getName()) && %slot $= 4 && %val)
			{
				%player.mountImage(%image.item.image @ "Scoped", 0);
				%player.client.setControlCameraFov(%image.item.gc_zoom);

				if(%vehicle !$= "")
				{
					schedule(100, 0, gc_remount, %vehicle, %player, %vehicleSlot);
				}
			}

			if(((%image.item.image @ "Scoped") $= %image.getName()) && %slot $= 4 && %val)
			{
				%player.mountImage(%image.item.image, 0);

				%var = %player.client.defaultZoom !$= "" ? %player.client.defaultZoom : 90;
				%player.client.setControlCameraFov(%var);

				if(%vehicle !$= "")
				{
					schedule(100, 0, gc_remount, %vehicle, %player, %vehicleSlot);
				}
			}

			parent::onTrigger(%this, %player, %slot, %val);
		}

		else
		{
			parent::onTrigger(%this, %player, %slot, %val);
		}
	}
};
activatePackage(gc_ScopesPackage);